#include "stdafx.h"
#include "EpgProgramList.h"




CEpgProgramList::CEpgProgramList()
{
	m_pEpgDll=NULL;
}


CEpgProgramList::~CEpgProgramList()
{
}


bool CEpgProgramList::UpdateProgramList()
{
	if (m_pEpgDll==NULL)
		return false;

	SERVICE_INFO *pService=NULL;
	DWORD dwServiceCount=0;

	Clear();
	if (!m_pEpgDll->GetServiceListDB(&pService,&dwServiceCount))
		return false;
	for (DWORD i=0;i<dwServiceCount;i++ ) {
		if (pService[i].dwServiceType!=0x01 && pService[i].dwServiceType!=0xA5)
			continue;
		SERVICE_INFO_DATA Item;
		Item.wOriginalNID=(WORD)pService[i].dwOriginalNID;
		Item.wTSID=(WORD)pService[i].dwTSID;
		Item.wServiceID=(WORD)pService[i].dwServiceID;
		if (pService[i].lpwszServiceName!=NULL) {
			Item.strServiceName=pService[i].lpwszServiceName;
		} else {
			Item.strServiceName=L"";
		}
		Item.wServiceType=(WORD)pService[i].dwServiceType;

		ULONGLONG i64Key=((ULONGLONG)Item.wOriginalNID)<<32 | ((ULONGLONG)Item.wTSID)<<16 | (ULONGLONG)Item.wServiceID;

		ServiceMap.insert(std::pair<ULONGLONG,SERVICE_INFO_DATA>(i64Key,Item));

		EPG_DATA_INFO2* pEpgData=NULL;
		DWORD dwEpgDataCount=0;
		if (m_pEpgDll->GetEpgDataListDB(Item.wOriginalNID,Item.wTSID,Item.wServiceID,&pEpgData,&dwEpgDataCount)) {
			EVENT_INFO_LIST Item2;
			EventMap.insert(std::pair<ULONGLONG,EVENT_INFO_LIST>(i64Key,Item2));
			std::map<ULONGLONG,EVENT_INFO_LIST>::iterator itr;

			itr=EventMap.find(i64Key);
			if (itr==EventMap.end())
				break;
			for (DWORD j=0;j<dwEpgDataCount;j++) {
				EVENT_INFO_DATA Item3;

				Item3.wOriginalNID=(WORD)pEpgData[j].dwOriginalNID;
				Item3.wTSID=(WORD)pEpgData[j].dwTSID;
				Item3.wServiceID=(WORD)pEpgData[j].dwServiceID;
				Item3.wEventID=(WORD)pEpgData[j].dwEventID;
				if (pEpgData[j].lpwszEventName!=NULL) {
					Item3.strEventName = pEpgData[j].lpwszEventName;
				} else {
					Item3.strEventName = L"";
				}
				if (pEpgData[j].lpwszEventText!=NULL) {
					Item3.strEventText = pEpgData[j].lpwszEventText;
				} else {
					Item3.strEventText = L"";
				}
				if (pEpgData[j].lpwszEventExtText!=NULL) {
					Item3.strEventExtText = pEpgData[j].lpwszEventExtText;
				} else {
					Item3.strEventExtText = L"";
				}
				Item3.stStartTime=pEpgData[j].stStartTime;
				Item3.dwDurationSec=pEpgData[j].dwDurationSec;
				Item3.ucComponentType=pEpgData[j].ucComponentType;
				if (pEpgData[j].lpwszComponentTypeText!=NULL) {
					Item3.strComponentTypeText=pEpgData[j].lpwszComponentTypeText;
				} else {
					Item3.strComponentTypeText=L"";
				}
				Item3.ucAudioComponentType=pEpgData[j].ucAudioComponentType;
				Item3.ucESMultiLangFlag=pEpgData[j].ucESMultiLangFlag;
				Item3.ucMainComponentFlag=pEpgData[j].ucMainComponentFlag;
				Item3.ucSamplingRate=pEpgData[j].ucSamplingRate;
				if (pEpgData[j].lpwszAudioComponentTypeText!=NULL) {
					Item3.strAudioComponentTypeText=pEpgData[j].lpwszAudioComponentTypeText;
				} else {
					Item3.strAudioComponentTypeText=L"";
				}
				for (DWORD k=0;k<pEpgData[j].dwContentNibbleListCount;k++) {
					NIBBLE_DATA Item4;

					Item4.ucContentNibbleLv1=(BYTE)((pEpgData[j].dwContentNibbleList[k]&0xFF000000) >> 24);
					Item4.ucContentNibbleLv2=(BYTE)((pEpgData[j].dwContentNibbleList[k]&0x00FF0000) >> 16);
					Item4.ucUserNibbleLv1=(BYTE)((pEpgData[j].dwContentNibbleList[k]&0x0000FF00) >> 8);
					Item4.ucUserNibbleLv2=(BYTE)(pEpgData[j].dwContentNibbleList[k]&0x000000FF);
					Item3.NibbleList.push_back(Item4);
				}
				itr->second.EventDataMap.insert(std::pair<WORD, EVENT_INFO_DATA>(Item3.wEventID,Item3));
			}
		}
	}
	return true;
}


void CEpgProgramList::Clear()
{
	ServiceMap.clear();
	EventMap.clear();
	//m_pEpgDll->ClearData();
}
