#include "stdafx.h"
#include <shlwapi.h>
#include <process.h>
#include "DtvEngine.h"
#include "HDUSTest.h"
#include "ChannelList.h"
#include "StatusView.h"
#include "InfoPanel.h"
#include "Information.h"
#include "EpgProgramList.h"
#include "ProgramListView.h"
#include "ControlPanel.h"
#include "RemoteController.h"
#include "NetworkRemocon.h"
#include "Record.h"
#include "Capture.h"
#include "StatusOptions.h"
#include "Settings.h"
#include "Image.h"
#include "PseudoOSD.h"
#include "resource.h"


#pragma warning(disable: 4995) // warning C4995: Oꂽ #pragma ƂċLqĂ܂B


#define MAIN_WINDOW_CLASS				TEXT("HDUSTest Window")
#define VIEW_WINDOW_CLASS				TEXT("HDUSTest View")
#define VIDEO_CONTAINER_WINDOW_CLASS	TEXT("HDUSTest Video Container")
#define FULLSCREEN_WINDOW_CLASS			TEXT("HDUSTest Fullscreen")

#define TITLE_TEXT TEXT("HDUSTest")

#define TIMER_ID_UPDATE		1
#define TIMER_ID_OSD		2
#define TIMER_ID_DISPLAY	3
#define TIMER_ID_WHEELCHANNELCHANGE			4
#define TIMER_ID_WHEELCHANNELCHANGE_DONE	5

#define MENU_POS_ZOOM			0
#define MENU_POS_ASPECTRATIO	1
#define MENU_POS_CHANNEL		5
#define MENU_POS_SERVICE		6
#define MENU_POS_SPACE			7
#define MENU_POS_VOLUME			9
#define MENU_POS_STEREOMODE		10

static HINSTANCE hInst;
static HWND hwndMain;
static HWND hwndView;
static HWND hwndVideoContainer;
static HMENU hmenuMain=NULL;
static HACCEL hAccel;
static CStatusView StatusView;

static int WindowLeft=CW_USEDEFAULT;
static int WindowTop=CW_USEDEFAULT;
static int WindowWidth=CW_USEDEFAULT;
static int WindowHeight=CW_USEDEFAULT;
static bool fWindowMaximize=false;
static bool fAlwaysOnTop=false;
static bool fFullscreen=false;
static bool fShowStatusBar=true;
static bool fShowTitleBar=true;

static TCHAR szIniFileName[MAX_PATH];
static TCHAR szDriverFileName[MAX_PATH];
static TCHAR szTempDriverFileName[MAX_PATH];
static HMODULE hDriverLib=NULL;
static bool fUDPDriver=false;
static bool fHDUSDriver=false;
static bool fNewHDUSDriver=false;
static unsigned int UDPPort=1234;

static TCHAR szChannelListFileName[MAX_PATH];
static CChannelList ChannelList;

static CRemoteController *pRemoteController=NULL;

static TCHAR szMpeg2DecoderName[128];
static bool fUseVMR9=false;
static bool fNoDescramble=false;
static bool fTempNoDescramble=false;
static bool fKeepSingleTask=false;
static bool fNoKeyHook=false;
static bool fNoRemoteController=false;
static bool fNoScreenSaver=false;
static BOOL fScreenSaverActive=FALSE;
static bool fNoMonitorLowPower=false;
static bool fNoMonitorLowPowerActiveOnly=false;
static BOOL fLowPowerActiveOriginal=FALSE,fPowerOffActiveOriginal=FALSE;
static bool fRestoreChannel=false;
static int OldChannel=0,OldSpace=-1;
static bool fAdjustAspectResizing=false;
static bool fSnapToWindowEdge=false;
static int SnapToWindowEdgeMargin=8;
static bool fConfirmRecChannelChange=false;
static bool fConfirmRecordingExit=true;
enum {
	WHEEL_MODE_NONE,
	WHEEL_MODE_VOLUME,
	WHEEL_MODE_CHANNEL,
	WHEEL_MODE_STEREOMODE,
	WHEEL_MODE_ZOOM
};
static int WheelMode=WHEEL_MODE_VOLUME;
static int WheelShiftMode=WHEEL_MODE_CHANNEL;
static bool fWheelChannelReverse=false;
static unsigned int WheelChannelDelay=1000;
static bool fWheelChannelChanging=false;
static int WheelCurrentChannelNo;
static bool fFunctionKeyChangeChannel=true;
static bool fDigitKeyChangeChannel=true;
static bool fNumPadChangeChannel=true;

static CDtvEngine DtvEngine;

static int NumSpaces=0;
static int CurrentSpace=0;
static int CurrentChannel=-1;
static int CurrentService=0;
#define MAX_VOLUME 100
static int CurrentVolume=100;
static bool fMute=false;
static int CurrentStereoMode=0;
static DWORD ErrorPacketCount=0;
static DWORD ScramblePacketCount=0;

static const int ZoomList[] = {25,33,50,66,75,100,150,200};
static int AspectRatioType=0;
static int VideoWidth=0;
static int VideoHeight=0;
static int PanAndScanVideoWidth=0;
static int PanAndScanVideoHeight=0;
static int CurrentNumAudioChannels=0;

static COLORREF crStatusBackColor=RGB(128,192,160);
static COLORREF crStatusTextColor=RGB(64,96,80);
static COLORREF crStatusHighlightBackColor=RGB(64,96,80);
static COLORREF crStatusHighlightTextColor=RGB(128,192,160);
static COLORREF crInfoBackColor=RGB(128,192,160);
static COLORREF crInfoTextColor=RGB(64,96,80);

static bool fUseOSD=false;
static bool fUsePseudoOSD=false;
static COLORREF crOSDTextColor=RGB(0,255,128);
static unsigned int OSDFadeTime=2000;
static CPseudoOSD PseudoOSD;

static bool fClientEdge=true;

static CStatusOptions StatusOptions(&StatusView);

static POINT ptDragStartPos;
static RECT rcDragStart;

static TCHAR szRecordSaveFolder[MAX_PATH];
static TCHAR szRecordFileName[MAX_PATH];
static bool fAddRecordTime=true;
static CRecordOption RecordOption;
static bool fRecording=false;

static TCHAR szCaptureSaveFolder[MAX_PATH];
static TCHAR szCaptureFileName[MAX_PATH];
static int CaptureSaveFormat=0;
static int JPEGQuality=90;
static int PNGCompressionLevel=6;
static bool fCaptureIconSaveToFile=false;
static bool fCaptureSetComment=false;
enum {
	CAPTURE_SIZE_ORIGINAL,
	CAPTURE_SIZE_VIEW,
	CAPTURE_SIZE_RAW,
	CAPTURE_SIZE_1920x1080,
	CAPTURE_SIZE_1440x810,
	CAPTURE_SIZE_1280x720,
	CAPTURE_SIZE_1024x576,
	CAPTURE_SIZE_960x540,
	CAPTURE_SIZE_800x450,
	CAPTURE_SIZE_640x360,
	CAPTURE_SIZE_1440x1080,
	CAPTURE_SIZE_1280x960,
	CAPTURE_SIZE_1024x768,
	CAPTURE_SIZE_800x600,
	CAPTURE_SIZE_720x540,
	CAPTURE_SIZE_640x480
};
#define CAPTURE_SIZE_CUSTOM_FIRST CAPTURE_SIZE_1920x1080
static SIZE CaptureSizeList[] = {
	{0,		0},
	{0,		0},
	{0,		0},
	// 16:9
	{1920,	1080},
	{1440,	810},
	{1280,	720},
	{1024,	576},
	{960,	540},
	{800,	450},
	{640,	360},
	// 4:3
	{1440,	1080},
	{1280,	960},
	{1024,	768},
	{800,	600},
	{720,	540},
	{640,	480},
};
static int CaptureSize=CAPTURE_SIZE_ORIGINAL;
static CImageCodec ImageCodec;
static CCapturePreview CapturePreview;
static bool fShowCapturePreview=false;
static bool fUseGrabberFilter=false;

static bool fUseNetworkRemocon=false;
static bool fUseNetworkRemoconCmd=false;
static char szNetworkRemoconAddress[16] = "127.0.0.1";
static unsigned int NetworkRemoconPort=0;
static CNetworkRemocon *pNetworkRemocon=NULL;
static TCHAR szNetworkRemoconChFile[MAX_PATH];
static int NetworkRemoconCurChannelNo=0;

static bool fShowInfoWindow=false;
static CInfoPanel InfoPanel;
static int InfoPanelCurTab=0;

static CInformation InfoWindow;

static CEpgProgramList EpgProgramList;
static bool fShowProgramList=false;
static CProgramListView ProgramListView;

static CControlPanel ControlPanel;
enum {
	CONTROLPANEL_ITEM_CHANNEL_1,
	CONTROLPANEL_ITEM_CHANNEL_2,
	CONTROLPANEL_ITEM_CHANNEL_3,
	CONTROLPANEL_ITEM_CHANNEL_4,
	CONTROLPANEL_ITEM_CHANNEL_5,
	CONTROLPANEL_ITEM_CHANNEL_6,
	CONTROLPANEL_ITEM_CHANNEL_7,
	CONTROLPANEL_ITEM_CHANNEL_8,
	CONTROLPANEL_ITEM_CHANNEL_9,
	CONTROLPANEL_ITEM_CHANNEL_10,
	CONTROLPANEL_ITEM_CHANNEL_11,
	CONTROLPANEL_ITEM_CHANNEL_12,
	CONTROLPANEL_ITEM_VOLUME,
	CONTROLPANEL_ITEM_OPTIONS
};



static bool LoadSettings()
{
	Settings Setting;

	if (Setting.Open(szIniFileName,TEXT("Settings"),Settings::OPEN_READ)) {
		int Value;
		TCHAR szText[MAX_PATH];

		Setting.Read(TEXT("WindowLeft"),&WindowLeft);
		Setting.Read(TEXT("WindowTop"),&WindowTop);
		Setting.Read(TEXT("WindowWidth"),&WindowWidth);
		Setting.Read(TEXT("WindowHeight"),&WindowHeight);
		Setting.Read(TEXT("WindowMaximize"),&fWindowMaximize);
		Setting.Read(TEXT("AlwaysOnTop"),&fAlwaysOnTop);
		Setting.Read(TEXT("Driver"),szDriverFileName,
												lengthof(szDriverFileName));
		Setting.Read(TEXT("Mpeg2Decoder"),szMpeg2DecoderName,
												lengthof(szMpeg2DecoderName));
		if (Setting.Read(TEXT("Volume"),&Value))
			CurrentVolume=Value<0?0:Value>MAX_VOLUME?MAX_VOLUME:Value;
		Setting.Read(TEXT("ShowInfoWindow"),&fShowInfoWindow);
		Setting.Read(TEXT("ShowStatusBar"),&fShowStatusBar);
		Setting.Read(TEXT("ShowTitleBar"),&fShowTitleBar);
		Setting.ReadColor(TEXT("StatusBkColor"),&crStatusBackColor);
		Setting.ReadColor(TEXT("StatusTextColor"),&crStatusTextColor);
		Setting.ReadColor(TEXT("StatusHighlightBackColor"),
												&crStatusHighlightBackColor);
		Setting.ReadColor(TEXT("StatusHighlightTextColor"),
												&crStatusHighlightTextColor);
		Setting.ReadColor(TEXT("InfoBackColor"),&crInfoBackColor);
		Setting.ReadColor(TEXT("InfoTextColor"),&crInfoTextColor);
		Setting.Read(TEXT("UseOSD"),&fUseOSD);
		Setting.Read(TEXT("PseudoOSD"),&fUsePseudoOSD);
		Setting.ReadColor(TEXT("OSDTextColor"),&crOSDTextColor);
		PseudoOSD.SetTextColor(crOSDTextColor);
		Setting.Read(TEXT("OSDFadeTime"),&OSDFadeTime);
		Setting.Read(TEXT("ClientEdge"),&fClientEdge);
		Setting.Read(TEXT("KeepSingleTask"),&fKeepSingleTask);
		Setting.Read(TEXT("NoRemoteController"),&fNoRemoteController);
		Setting.Read(TEXT("NoKeyHook"),&fNoKeyHook);
		Setting.Read(TEXT("NoScreenSaver"),&fNoScreenSaver);
		Setting.Read(TEXT("NoMonitorLowPower"),&fNoMonitorLowPower);
		Setting.Read(TEXT("NoMonitorLowPowerActiveOnly"),
												&fNoMonitorLowPowerActiveOnly);
		Setting.Read(TEXT("AdjustAspectResizing"),&fAdjustAspectResizing);
		Setting.Read(TEXT("SnapToWindowEdge"),&fSnapToWindowEdge);
		Setting.Read(TEXT("NoDescramble"),&fNoDescramble);
		Setting.Read(TEXT("RestoreChannel"),&fRestoreChannel);
		Setting.Read(TEXT("CurChannel"),&OldChannel);
		Setting.Read(TEXT("CurSpace"),&OldSpace);
		Setting.Read(TEXT("ConfirmRecChChange"),&fConfirmRecChannelChange);
		Setting.Read(TEXT("ConfrimRecordingExit"),&fConfirmRecordingExit);
		Setting.Read(TEXT("WheelMode"),&WheelMode);
		Setting.Read(TEXT("WheelShiftMode"),&WheelShiftMode);
		Setting.Read(TEXT("ReverseWheelChannel"),&fWheelChannelReverse);
		Setting.Read(TEXT("WheelChannelDelay"),&WheelChannelDelay);
		Setting.Read(TEXT("FuncKeyChangeChannel"),&fFunctionKeyChangeChannel);
		Setting.Read(TEXT("DigitKeyChangeChannel"),&fDigitKeyChangeChannel);
		// Backward compatibility
		if (Setting.Read(TEXT("RecordFile"),szRecordFileName,
												lengthof(szRecordFileName))) {
			LPTSTR pszFileName=PathFindFileName(szRecordFileName);

			if (pszFileName!=szRecordFileName) {
				*(pszFileName-1)='\0';
				lstrcpy(szRecordSaveFolder,szRecordFileName);
				lstrcpy(szRecordFileName,pszFileName);
			}
		}
		Setting.Read(TEXT("RecordFolder"),szRecordSaveFolder,
												lengthof(szRecordSaveFolder));
		Setting.Read(TEXT("RecordFileName"),szRecordFileName,
												lengthof(szRecordFileName));
		Setting.Read(TEXT("AddRecordTime"),&fAddRecordTime);
		if (Setting.Read(TEXT("RecOptionFileName"),szText,MAX_PATH))
			RecordOption.SetFileName(szText);
		if (Setting.Read(TEXT("RecOptionExistsOperation"),&Value))
			RecordOption.SetFileExistsOperation(
								(CRecordOption::FileExistsOperation)Value);
		/*
		bool f;
		if (Setting.Read(TEXT("RecOptionStopTimeSpec"),&f))
			RecordOption.SetStopTimeSpec(f);
		unsigned int Time;
		if (Setting.Read(TEXT("RecOptionStopTime"),&Time))
			RecordOption.SetStopTime(Time);
		*/
		Setting.Read(TEXT("CaptureFolder"),szCaptureSaveFolder,
												lengthof(szCaptureSaveFolder));
		Setting.Read(TEXT("CaptureFileName"),szCaptureFileName,
												lengthof(szCaptureFileName));
		if (Setting.Read(TEXT("CaptureSaveFormat"),szText,lengthof(szText))) {
			int Format=ImageCodec.FormatNameToIndex(szText);
			if (Format>=0)
				CaptureSaveFormat=Format;
		}
		Setting.Read(TEXT("CaptureIconSaveFile"),&fCaptureIconSaveToFile);
		Setting.Read(TEXT("CaptureSetComment"),&fCaptureSetComment);
		if (Setting.Read(TEXT("CaptureSizeType"),&Value)
				&& Value>=0 && Value<=CAPTURE_SIZE_CUSTOM_FIRST)
			CaptureSize=Value;
		if (CaptureSize==CAPTURE_SIZE_CUSTOM_FIRST) {
			int Width,Height;
			Setting.Read(TEXT("CaptureWidth"),&Width);
			Setting.Read(TEXT("CaptureHeight"),&Height);
			CaptureSize=CAPTURE_SIZE_ORIGINAL;
			for (int i=CAPTURE_SIZE_CUSTOM_FIRST;i<lengthof(CaptureSizeList);i++) {
				if (CaptureSizeList[i].cx==Width && CaptureSizeList[i].cy==Height) {
					CaptureSize=i;
					break;
				}
			}
		}
		Setting.Read(TEXT("JpegQuality"),&JPEGQuality);
		Setting.Read(TEXT("PngCompressionLevel"),&PNGCompressionLevel);
		Setting.Read(TEXT("NumPadChangeChannel"),&fNumPadChangeChannel);
		Setting.Read(TEXT("UseNetworkRemocon"),&fUseNetworkRemocon);
		if (Setting.Read(TEXT("NetworkRemoconAddress"),szText,16))
			WideCharToMultiByte(CP_ACP,0,szText,-1,szNetworkRemoconAddress,
								lengthof(szNetworkRemoconAddress),NULL,NULL);
		Setting.Read(TEXT("NetworkRemoconPort"),&NetworkRemoconPort);
		Setting.Read(TEXT("NetworkRemoconChFile"),szNetworkRemoconChFile,
											lengthof(szNetworkRemoconChFile));
		int Left,Top,Width,Height;
		InfoPanel.GetPosition(&Left,&Top,&Width,&Height);
		Setting.Read(TEXT("InfoLeft"),&Left);
		Setting.Read(TEXT("InfoTop"),&Top);
		Setting.Read(TEXT("InfoWidth"),&Width);
		Setting.Read(TEXT("InfoHeight"),&Height);
		InfoPanel.SetPosition(Left,Top,Width,Height);
		InfoPanel.MoveToMonitorInside();
		Setting.Read(TEXT("InfoCurTab"),&InfoPanelCurTab);
		CapturePreview.GetPosition(&Left,&Top,&Width,&Height);
		Setting.Read(TEXT("CapturePreviewLeft"),&Left);
		Setting.Read(TEXT("CapturePreviewTop"),&Top);
		Setting.Read(TEXT("CapturePreviewWidth"),&Width);
		Setting.Read(TEXT("CapturePreviewHeight"),&Height);
		CapturePreview.SetPosition(Left,Top,Width,Height);
		CapturePreview.MoveToMonitorInside();
		TCHAR szRenderer[16];
		if (Setting.Read(TEXT("Renderer"),szRenderer,lengthof(szRenderer))) {
			fUseVMR9=lstrcmpi(szRenderer,TEXT("VMR9"))==0;
		}
		if (Setting.Read(TEXT("HDUSDriverVersion"),&Value))
			fNewHDUSDriver=Value==2;
		Setting.Read(TEXT("UseGrabber"),&fUseGrabberFilter);
		Setting.Close();
	} else
		return false;
	StatusOptions.Load(szIniFileName);
	return true;
}


static bool SaveSettings()
{
	Settings Setting;

	if (Setting.Open(szIniFileName,TEXT("Settings"),Settings::OPEN_WRITE)) {
		int Value;

		Setting.Write(TEXT("WindowLeft"),WindowLeft);
		Setting.Write(TEXT("WindowTop"),WindowTop);
		Setting.Write(TEXT("WindowWidth"),WindowWidth);
		Setting.Write(TEXT("WindowHeight"),WindowHeight);
		Setting.Write(TEXT("WindowMaximize"),fWindowMaximize);
		Setting.Write(TEXT("AlwaysOnTop"),fAlwaysOnTop);
		Setting.Write(TEXT("Driver"),szDriverFileName);
		Setting.Write(TEXT("Mpeg2Decoder"),szMpeg2DecoderName);
		Setting.Write(TEXT("Renderer"),fUseVMR9?TEXT("VMR9"):TEXT(""));
		Setting.Write(TEXT("Volume"),CurrentVolume);
		Setting.Write(TEXT("ShowInfoWindow"),fShowInfoWindow);
		Setting.Write(TEXT("ShowStatusBar"),fShowStatusBar);
		Setting.Write(TEXT("ShowTitleBar"),fShowTitleBar);
		Setting.WriteColor(TEXT("StatusBkColor"),crStatusBackColor);
		Setting.WriteColor(TEXT("StatusTextColor"),crStatusTextColor);
		Setting.WriteColor(TEXT("StatusHighlightBackColor"),
												crStatusHighlightBackColor);
		Setting.WriteColor(TEXT("StatusHighlightTextColor"),
												crStatusHighlightTextColor);
		Setting.WriteColor(TEXT("InfoBackColor"),crInfoBackColor);
		Setting.WriteColor(TEXT("InfoTextColor"),crInfoTextColor);
		Setting.Write(TEXT("UseOSD"),fUseOSD);
		Setting.Write(TEXT("PseudoOSD"),fUsePseudoOSD);
		Setting.WriteColor(TEXT("OSDTextColor"),crOSDTextColor);
		Setting.Write(TEXT("OSDFadeTime"),OSDFadeTime);
		Setting.Write(TEXT("ClientEdge"),fClientEdge);
		Setting.Write(TEXT("KeepSingleTask"),fKeepSingleTask);
		Setting.Write(TEXT("NoRemoteController"),fNoRemoteController);
		Setting.Write(TEXT("NoKeyHook"),fNoKeyHook);
		Setting.Write(TEXT("NoScreenSaver"),fNoScreenSaver);
		Setting.Write(TEXT("NoMonitorLowPower"),fNoMonitorLowPower);
		Setting.Write(TEXT("NoMonitorLowPowerActiveOnly"),
												fNoMonitorLowPowerActiveOnly);
		Setting.Write(TEXT("AdjustAspectResizing"),fAdjustAspectResizing);
		Setting.Write(TEXT("SnapToWindowEdge"),fSnapToWindowEdge);
		Setting.Write(TEXT("NoDescramble"),fNoDescramble);
		Setting.Write(TEXT("RestoreChannel"),fRestoreChannel);
		Setting.Write(TEXT("CurChannel"),OldChannel);
		Setting.Write(TEXT("CurSpace"),OldSpace);
		Setting.Write(TEXT("ConfirmRecChChange"),fConfirmRecChannelChange);
		Setting.Write(TEXT("ConfrimRecordingExit"),fConfirmRecordingExit);
		Setting.Write(TEXT("WheelMode"),WheelMode);
		Setting.Write(TEXT("WheelShiftMode"),WheelShiftMode);
		Setting.Write(TEXT("ReverseWheelChannel"),fWheelChannelReverse);
		Setting.Write(TEXT("WheelChannelDelay"),WheelChannelDelay);
		Setting.Write(TEXT("FuncKeyChangeChannel"),fFunctionKeyChangeChannel);
		Setting.Write(TEXT("DigitKeyChangeChannel"),fDigitKeyChangeChannel);
		Setting.Write(TEXT("NumPadChangeChannel"),fNumPadChangeChannel);
		//Setting.Write(TEXT("RecordFile"),szRecordFileName);
		Setting.Write(TEXT("RecordFolder"),szRecordSaveFolder);
		Setting.Write(TEXT("RecordFileName"),szRecordFileName);
		Setting.Write(TEXT("AddRecordTime"),fAddRecordTime);
		Setting.Write(TEXT("RecOptionFileName"),RecordOption.GetFileName());
		Setting.Write(TEXT("RecOptionExistsOperation"),
										RecordOption.GetFileExistsOperation());
		/*
		Setting.Write(TEXT("RecOptionStopTimeSpec"),
											RecordOption.GetStopTimeSpec());
		Setting.Write(TEXT("RecOptionStopTime"),RecordOption.GetStopTime());
		*/
		Setting.Write(TEXT("CaptureFolder"),szCaptureSaveFolder);
		Setting.Write(TEXT("CaptureFileName"),szCaptureFileName);
		Setting.Write(TEXT("CaptureSaveFormat"),
								ImageCodec.EnumSaveFormat(CaptureSaveFormat));
		Setting.Write(TEXT("CaptureIconSaveFile"),fCaptureIconSaveToFile);
		Setting.Write(TEXT("CaptureSetComment"),fCaptureSetComment);
		Setting.Write(TEXT("CaptureSizeType"),
			CaptureSize<CAPTURE_SIZE_CUSTOM_FIRST?
										CaptureSize:CAPTURE_SIZE_CUSTOM_FIRST);
		if (CaptureSize>=CAPTURE_SIZE_CUSTOM_FIRST) {
			Setting.Write(TEXT("CaptureWidth"),CaptureSizeList[CaptureSize].cx);
			Setting.Write(TEXT("CaptureHeight"),CaptureSizeList[CaptureSize].cy);
		}
		Setting.Write(TEXT("JpegQuality"),JPEGQuality);
		Setting.Write(TEXT("PngCompressionLevel"),PNGCompressionLevel);
		Setting.Write(TEXT("UseNetworkRemocon"),fUseNetworkRemocon);
		TCHAR szAddress[16];
		MultiByteToWideChar(CP_ACP,0,szNetworkRemoconAddress,-1,
												szAddress,lengthof(szAddress));
		Setting.Write(TEXT("NetworkRemoconAddress"),szAddress);
		Setting.Write(TEXT("NetworkRemoconPort"),NetworkRemoconPort);
		Setting.Write(TEXT("NetworkRemoconChFile"),szNetworkRemoconChFile);
		int Left,Top,Width,Height;
		InfoPanel.GetPosition(&Left,&Top,&Width,&Height);
		Setting.Write(TEXT("InfoLeft"),Left);
		Setting.Write(TEXT("InfoTop"),Top);
		Setting.Write(TEXT("InfoWidth"),Width);
		Setting.Write(TEXT("InfoHeight"),Height);
		Setting.Write(TEXT("InfoCurTab"),InfoPanel.GetCurTab());
		CapturePreview.GetPosition(&Left,&Top,&Width,&Height);
		Setting.Write(TEXT("CapturePreviewLeft"),Left);
		Setting.Write(TEXT("CapturePreviewTop"),Top);
		Setting.Write(TEXT("CapturePreviewWidth"),Width);
		Setting.Write(TEXT("CapturePreviewHeight"),Height);
		Setting.Write(TEXT("HDUSDriverVersion"),fNewHDUSDriver?2:1);
		Setting.Close();
	} else
		return false;
	StatusOptions.Save(szIniFileName);
	return true;
}


static void GetNetworkRemoconChFilePath(LPCTSTR pszFileName,LPTSTR pszPath)
{
	if (pszFileName[0]=='\0') {
		lstrcpy(pszPath,TEXT("BonDriver_HDUS(HDUS).ChSet.txt"));
	} else if (PathIsRelative(pszFileName)) {
		SHGetSpecialFolderPath(NULL,pszPath,CSIDL_PERSONAL,FALSE);
		PathAppend(pszPath,TEXT("EpgTimerBon"));
		PathAppend(pszPath,pszFileName);
	} else
		lstrcpy(pszPath,pszFileName);
}


static void AdjustAspect(int *pWidth,int *pHeight,int XAspect,int YAspect)
{
	int Width=*pWidth,Height=*pHeight;
	/*
	double SrcAspect,DstAspect;

	SrcAspect=(double)Width/(double)Height;
	DstAspect=(double)XAspect/(double)YAspect;
	if (SrcAspect<DstAspect)
		Height=Width*YAspect/XAspect;
	else if (SrcAspect>DstAspect)
		Width=Height*XAspect/YAspect;
	*/
	Width=Height*XAspect/YAspect;
	*pWidth=Width;
	*pHeight=Height;
}


static int CalcZoomRate()
{
	RECT rc;
	int Zoom;

	if (PanAndScanVideoWidth>0 && PanAndScanVideoHeight>0) {
		int Width,Height;
		BYTE XAspect,YAspect;

		GetClientRect(hwndView,&rc);
		Width=PanAndScanVideoWidth;
		Height=PanAndScanVideoHeight;
		if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(&XAspect,&YAspect))
			AdjustAspect(&Width,&Height,XAspect,YAspect);
		Zoom=(rc.bottom*100+Height/2)/Height;
	} else
		Zoom=0;
	return Zoom;
}


static HMENU GetTopMenu(int Pos)
{
	return GetSubMenu(GetSubMenu(hmenuMain,0),Pos);
}


static void SetDisplayStatus()
{
	if (!fNoScreenSaver && fScreenSaverActive) {
		SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,TRUE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
		fScreenSaverActive=FALSE;
	}
	if (!fNoMonitorLowPower) {
		if (fPowerOffActiveOriginal) {
			SystemParametersInfo(SPI_SETPOWEROFFACTIVE,TRUE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
			fPowerOffActiveOriginal=FALSE;
		}
		if (fLowPowerActiveOriginal) {
			SystemParametersInfo(SPI_SETLOWPOWERACTIVE,TRUE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
			fLowPowerActiveOriginal=FALSE;
		}
	}
	if (fNoScreenSaver && fNoMonitorLowPower && !fNoMonitorLowPowerActiveOnly) {
		// SetThreadExecutionState() Ăԃ^C}[
		SetTimer(hwndMain,TIMER_ID_DISPLAY,30000,NULL);
	} else {
		KillTimer(hwndMain,TIMER_ID_DISPLAY);
		if (fNoScreenSaver && !fScreenSaverActive) {
			if (!SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,
														&fScreenSaverActive,0))
				fScreenSaverActive=FALSE;
			if (fScreenSaverActive)
				SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,FALSE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
		}
		if (fNoMonitorLowPower && !fNoMonitorLowPowerActiveOnly) {
			if (!fPowerOffActiveOriginal) {
				if (!SystemParametersInfo(SPI_GETPOWEROFFACTIVE,0,
												&fPowerOffActiveOriginal,0))
					fPowerOffActiveOriginal=FALSE;
				if (fPowerOffActiveOriginal)
					SystemParametersInfo(SPI_SETPOWEROFFACTIVE,FALSE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
			}
			if (!fLowPowerActiveOriginal) {
				if (!SystemParametersInfo(SPI_GETLOWPOWERACTIVE,0,
												&fLowPowerActiveOriginal,0))
					fLowPowerActiveOriginal=FALSE;
				if (fLowPowerActiveOriginal)
					SystemParametersInfo(SPI_SETLOWPOWERACTIVE,FALSE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
			}
		}
	}
}




static bool LoadChannelList(CChannelList *pList,LPCTSTR pszFileName)
{
	HANDLE hFile;
	DWORD Size,Read;
	char *pszText,*p,*q;
	TCHAR szName[MAX_CHANNEL_NAME];
	int i;
	int Space,ChannelNo,Channel;

	hFile=CreateFile(pszFileName,GENERIC_READ,FILE_SHARE_READ,NULL,
														OPEN_EXISTING,0,NULL);
	if (hFile==INVALID_HANDLE_VALUE)
		return false;
	Size=GetFileSize(hFile,NULL);
	if (Size==0) {
		CloseHandle(hFile);
		return false;
	}
	pszText=new char[Size+1];
	if (!ReadFile(hFile,pszText,Size,&Read,NULL) || Read!=Size) {
		delete [] pszText;
		CloseHandle(hFile);
		return false;
	}
	CloseHandle(hFile);
	pszText[Size]='\0';
	p=pszText;
	do {
		while (*p=='\r' || *p=='\n')
			p++;
		if (*p=='\0')
			break;
		q=p;
		while (*p!=',' && *p!='\0') {
			if (IsDBCSLeadByteEx(CP_ACP,*p) && *(p+1)!='\0')
				p++;
			p++;
		}
		if (*p!=',')
			break;
		*p++='\0';
#ifdef UNICODE
		MultiByteToWideChar(CP_ACP,0,q,-1,szName,MAX_CHANNEL_NAME);
#else
		lstrcpyn(szName,q,MAX_CHANNEL_NAME);
#endif
		ChannelNo=0;
		while (*p>='0' && *p<='9') {
			ChannelNo=ChannelNo*10+(*p-'0');
			p++;
		}
		if (*p!=',')
			break;
		p++;
		if (*p=='C') {
			Space=1;
			p++;
		} else
			Space=0;
		Channel=0;
		while (*p>='0' && *p<='9') {
			Channel=Channel*10+(*p-'0');
			p++;
		}
		if (ChannelNo>0 && Channel>0)
			pList->AddChannel(Space,Channel,ChannelNo,szName);
		while (*p!='\r' && *p!='\n' && *p!='\0')
			p++;
	} while (*p!='\0');
	return true;
}


struct ChannelInfo {
	int ChannelNo;
	TCHAR szName[MAX_CHANNEL_NAME];
};


static bool GetCurrentChannelInfo(ChannelInfo *pInfo)
{
	if (pNetworkRemocon!=NULL && NetworkRemoconCurChannelNo>0) {
		const CChannelList &List=pNetworkRemocon->GetChannelList();
		int i=List.FindChannelNo(NetworkRemoconCurChannelNo);

		pInfo->ChannelNo=List.GetChannelNo(i);
		lstrcpy(pInfo->szName,List.GetName(i));
	} else if (CurrentChannel>=0) {
		pInfo->ChannelNo=ChannelList.GetChannelNo(CurrentChannel);
		lstrcpy(pInfo->szName,ChannelList.GetName(CurrentChannel));
	} else
		return false;
	return true;
}


static bool GetChangingChannelInfo(ChannelInfo *pInfo)
{
	int Channel;

	if (!fWheelChannelChanging)
		return false;
	pInfo->ChannelNo=WheelCurrentChannelNo;
	if (pNetworkRemocon!=NULL) {
		const CChannelList &List=pNetworkRemocon->GetChannelList();

		Channel=List.FindChannelNo(WheelCurrentChannelNo);
		lstrcpy(pInfo->szName,List.GetName(Channel));
	} else {
		Channel=ChannelList.FindChannelNo(WheelCurrentChannelNo);
		lstrcpy(pInfo->szName,ChannelList.GetName(Channel));
	}
	return true;
}


static int GetNextChannel(bool fNext)
{
	int Channel;

	if (pNetworkRemocon!=NULL) {
		const CChannelList &List=pNetworkRemocon->GetChannelList();

		if (fWheelChannelChanging)
			Channel=WheelCurrentChannelNo;
		else
			Channel=NetworkRemoconCurChannelNo;
		if (fNext)
			Channel=List.GetNextChannelNo(Channel,true);
		else
			Channel=List.GetPrevChannelNo(Channel,true);
	} else if (CurrentChannel>=0) {
		if (fWheelChannelChanging)
			Channel=WheelCurrentChannelNo;
		else
			Channel=ChannelList.GetChannelNo(CurrentChannel);
		if (fNext)
			Channel=ChannelList.GetNextChannelNo(Channel,true);
		else
			Channel=ChannelList.GetPrevChannelNo(Channel,true);
	} else
		return 0;
	return Channel;
}




class CChannelStatusItem : public CStatusItem {
public:
	CChannelStatusItem();
	LPCTSTR GetName() const { return TEXT("`l"); }
	void Draw(HDC hdc,const RECT *pRect);
	void DrawPreview(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
};

CChannelStatusItem::CChannelStatusItem() : CStatusItem(STATUS_ITEM_CHANNEL,96)
{
}

void CChannelStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	ChannelInfo Info;
	TCHAR szText[4+MAX_CHANNEL_NAME];

	if (fWheelChannelChanging) {
		COLORREF crText,crBack;

		crText=GetTextColor(hdc);
		crBack=GetBkColor(hdc);
		SetTextColor(hdc,RGB((GetRValue(crText)+GetRValue(crBack))/2,
							(GetGValue(crText)+GetGValue(crBack))/2,
							(GetBValue(crText)+GetBValue(crBack))/2));
		GetChangingChannelInfo(&Info);
		wsprintf(szText,TEXT("%d: %s"),Info.ChannelNo,Info.szName);
	} else if (GetCurrentChannelInfo(&Info)) {
		wsprintf(szText,TEXT("%d: %s"),Info.ChannelNo,Info.szName);
	} else
		lstrcpy(szText,TEXT("<`l>"));
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CChannelStatusItem::DrawPreview(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,TEXT("AtJer"),-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CChannelStatusItem::OnLButtonDown(int x,int y)
{
	RECT rc;
	POINT pt;

	GetRect(&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetTopMenu(MENU_POS_CHANNEL),TPM_RIGHTBUTTON,
													pt.x,pt.y,0,hwndMain,NULL);
}


class CVideoSizeStatusItem : public CStatusItem {
public:
	CVideoSizeStatusItem();
	LPCTSTR GetName() const { return TEXT("fTCY"); }
	void Draw(HDC hdc,const RECT *pRect);
	void DrawPreview(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
};

CVideoSizeStatusItem::CVideoSizeStatusItem() : CStatusItem(STATUS_ITEM_VIDEOSIZE,120)
{
}

void CVideoSizeStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[32];
	wsprintf(szText,TEXT("%d x %d (%d %%)"),VideoWidth,VideoHeight,
															CalcZoomRate());
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CVideoSizeStatusItem::DrawPreview(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,TEXT("1920 x 1080 (100 %)"),-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CVideoSizeStatusItem::OnLButtonDown(int x,int y)
{
	RECT rc;
	POINT pt;

	GetRect(&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetTopMenu(MENU_POS_ZOOM),TPM_RIGHTBUTTON,pt.x,pt.y,
															0,hwndMain,NULL);
}


class CVolumeStatusItem : public CStatusItem {
public:
	CVolumeStatusItem();
	LPCTSTR GetName() const { return TEXT(""); }
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
	void OnMouseMove(int x,int y);
};

CVolumeStatusItem::CVolumeStatusItem() : CStatusItem(STATUS_ITEM_VOLUME,80)
{
}

void CVolumeStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	HPEN hpen,hpenOld;
	HBRUSH hbr,hbrOld;
	RECT rc;
	COLORREF crBar;

	hpen=CreatePen(PS_SOLID,1,GetTextColor(hdc));
	hpenOld=(HPEN)SelectObject(hdc,hpen);
	hbrOld=(HBRUSH)SelectObject(hdc,GetStockObject(NULL_BRUSH));
	rc.left=pRect->left;
	rc.top=pRect->top+(pRect->bottom-pRect->top-8)/2;
	rc.right=pRect->right;
	rc.bottom=rc.top+8;
	Rectangle(hdc,rc.left,rc.top,rc.right,rc.bottom);
	SelectObject(hdc,hbrOld);
	SelectObject(hdc,hpenOld);
	DeleteObject(hpen);
	if (!fMute) {
		crBar=GetTextColor(hdc);
	} else {
		COLORREF crText,crBk;

		crText=GetTextColor(hdc);
		crBk=GetBkColor(hdc);
		crBar=RGB((GetRValue(crText)+GetRValue(crBk))/2,
				  (GetGValue(crText)+GetGValue(crBk))/2,
				  (GetBValue(crText)+GetBValue(crBk))/2);
	}
	hbr=CreateSolidBrush(crBar);
	rc.left+=2;
	rc.top+=2;
	rc.right=rc.left+(rc.right-2-rc.left)*CurrentVolume/MAX_VOLUME;
	rc.bottom-=2;
	FillRect(hdc,&rc,hbr);
	DeleteObject(hbr);
}

void CVolumeStatusItem::OnLButtonDown(int x,int y)
{
	OnMouseMove(x,y);
	SetCapture(m_pStatus->GetHandle());
}

void CVolumeStatusItem::OnRButtonDown(int x,int y)
{
	SendMessage(hwndMain,WM_COMMAND,CM_VOLUME_MUTE,0);
}

static void SetVolume(int Volume,bool fOSD=true);

void CVolumeStatusItem::OnMouseMove(int x,int y)
{
	RECT rc;
	int Volume;

	GetRect(&rc);
	Volume=(x-2)*100/(rc.right-rc.left-4-1);
	if (Volume<0)
		Volume=0;
	else if (Volume>MAX_VOLUME)
		Volume=MAX_VOLUME;
	if (fMute || Volume!=CurrentVolume)
		SetVolume(Volume,false);
}


class CAudioChannelStatusItem : public CStatusItem {
public:
	CAudioChannelStatusItem();
	LPCTSTR GetName() const { return TEXT(""); }
	void Draw(HDC hdc,const RECT *pRect);
	void DrawPreview(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
};

CAudioChannelStatusItem::CAudioChannelStatusItem() : CStatusItem(STATUS_ITEM_AUDIOCHANNEL,64)
{
}

void CAudioChannelStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[32];

	if (CurrentNumAudioChannels>0) {
		switch (CurrentNumAudioChannels) {
		case 1:
			lstrcpy(szText,TEXT("Mono"));
			break;
		case 2:
			lstrcpy(szText,TEXT("Stereo"));
			if (CurrentStereoMode!=0)
				lstrcat(szText,CurrentStereoMode==1?TEXT("(L)"):TEXT("(R)"));
			break;
		case 6:
			lstrcpy(szText,TEXT("5.1ch"));
			break;
		default:
			wsprintf(szText,TEXT("%dch"),CurrentNumAudioChannels);
			break;
		}
	} else
		lstrcpy(szText,TEXT("<>"));
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CAudioChannelStatusItem::DrawPreview(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,TEXT("Stereo"),-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CAudioChannelStatusItem::OnLButtonDown(int x,int y)
{
	if (CurrentNumAudioChannels==2)
		SendMessage(hwndMain,WM_COMMAND,CM_STEREOMODE,0);
	else
		OnRButtonDown(x,y);
}

void CAudioChannelStatusItem::OnRButtonDown(int x,int y)
{
	RECT rc;
	POINT pt;

	GetRect(&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetTopMenu(MENU_POS_STEREOMODE),TPM_RIGHTBUTTON,pt.x,pt.y,
															0,hwndMain,NULL);
}


class CRecordStatusItem : public CStatusItem {
public:
	CRecordStatusItem();
	LPCTSTR GetName() const { return TEXT("^"); }
	void Draw(HDC hdc,const RECT *pRect);
	void DrawPreview(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
};

CRecordStatusItem::CRecordStatusItem() : CStatusItem(STATUS_ITEM_RECORD,64)
{
}

void CRecordStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,fRecording?TEXT(" ^撆"):TEXT(""),-1,
		const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CRecordStatusItem::DrawPreview(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,TEXT(" ^撆"),-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CRecordStatusItem::OnLButtonDown(int x,int y)
{
	SendMessage(hwndMain,WM_COMMAND,CM_RECORD,0);
}

void CRecordStatusItem::OnRButtonDown(int x,int y)
{
	HMENU hmenu;
	RECT rc;
	POINT pt;

	hmenu=LoadMenu(hInst,MAKEINTRESOURCE(IDM_RECORD));
	/*
	CheckMenuItem(hmenu,CM_ADDRECORDTIME,
					MF_BYCOMMAND | (fAddRecordTime?MFS_CHECKED:MFS_UNCHECKED));
	*/
	EnableMenuItem(hmenu,CM_RECORDSTOPTIME,
						MF_BYCOMMAND | (fRecording?MFS_ENABLED:MFS_GRAYED));
	GetRect(&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(hmenu,0),TPM_RIGHTBUTTON,pt.x,pt.y,0,hwndMain,
																		NULL);
	DestroyMenu(hmenu);
}


class CCaptureStatusItem : public CStatusItem {
	HBITMAP m_hbmIcon;
public:
	CCaptureStatusItem();
	~CCaptureStatusItem();
	LPCTSTR GetName() const { return TEXT("Lv`"); }
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
};

CCaptureStatusItem::CCaptureStatusItem() : CStatusItem(STATUS_ITEM_CAPTURE,16)
{
	m_MinWidth=16;
	m_hbmIcon=NULL;
}

CCaptureStatusItem::~CCaptureStatusItem()
{
	DeleteObject(m_hbmIcon);
}

void CCaptureStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	HDC hdcMem;
	HBITMAP hbmOld;
	RGBQUAD Palette[2];
	COLORREF cr,crTrans;

	if (m_hbmIcon==NULL)
		m_hbmIcon=static_cast<HBITMAP>(LoadImage(hInst,
								MAKEINTRESOURCE(IDB_CAPTURE),IMAGE_BITMAP,0,0,
								LR_DEFAULTCOLOR | LR_CREATEDIBSECTION));
	hdcMem=CreateCompatibleDC(hdc);
	hbmOld=(HBITMAP)SelectObject(hdcMem,m_hbmIcon);
	cr=GetTextColor(hdc);
	Palette[0].rgbBlue=GetBValue(cr);
	Palette[0].rgbGreen=GetGValue(cr);
	Palette[0].rgbRed=GetRValue(cr);
	crTrans=cr^0x00FFFFFF;
	Palette[1].rgbBlue=GetBValue(crTrans);
	Palette[1].rgbGreen=GetGValue(crTrans);
	Palette[1].rgbRed=GetRValue(crTrans);
	SetDIBColorTable(hdcMem,0,2,Palette);
	TransparentBlt(hdc,
					pRect->left+(pRect->right-pRect->left-16)/2,
					pRect->top+(pRect->bottom-pRect->top-16)/2,
					16,16,hdcMem,0,0,16,16,crTrans);
	SelectObject(hdcMem,hbmOld);
	DeleteDC(hdcMem);
}

void CCaptureStatusItem::OnLButtonDown(int x,int y)
{
	SendMessage(hwndMain,WM_COMMAND,CM_CAPTURE,0);
}

void CCaptureStatusItem::OnRButtonDown(int x,int y)
{
	HMENU hmenu;
	RECT rc;
	POINT pt;

	hmenu=LoadMenu(hInst,MAKEINTRESOURCE(IDM_CAPTURE));
	CheckMenuRadioItem(hmenu,CM_CAPTURESIZE_FIRST,CM_CAPTURESIZE_LAST,
								CM_CAPTURESIZE_FIRST+CaptureSize,MF_BYCOMMAND);
	if (fShowCapturePreview)
		CheckMenuItem(hmenu,CM_CAPTUREPREVIEW,MF_BYCOMMAND | MFS_CHECKED);
	GetRect(&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(hmenu,0),TPM_RIGHTBUTTON,pt.x,pt.y,0,hwndMain,
																		NULL);
	DestroyMenu(hmenu);
}


class CErrorStatusItem : public CStatusItem {
public:
	CErrorStatusItem();
	LPCTSTR GetName() const { return TEXT("G["); }
	void Draw(HDC hdc,const RECT *pRect);
	void DrawPreview(HDC hdc,const RECT *pRect);
};

CErrorStatusItem::CErrorStatusItem() : CStatusItem(STATUS_ITEM_ERROR,120)
{
}

void CErrorStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[64];
	int Length;

	Length=wsprintf(szText,TEXT("E %u"),ErrorPacketCount);
	if (!fNoDescramble)
		wsprintf(szText+Length,TEXT(" / S %u"),ScramblePacketCount);
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CErrorStatusItem::DrawPreview(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,TEXT("E 0 / S 127"),-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}


class CSignalLevelStatusItem : public CStatusItem {
public:
	CSignalLevelStatusItem();
	LPCTSTR GetName() const { return TEXT("Mx"); }
	void Draw(HDC hdc,const RECT *pRect);
	void DrawPreview(HDC hdc,const RECT *pRect);
};

CSignalLevelStatusItem::CSignalLevelStatusItem() : CStatusItem(STATUS_ITEM_SIGNALLEVEL,120)
{
}

void CSignalLevelStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	float SignalLevel;
	int Level;
	TCHAR szText[64];

	SignalLevel=DtvEngine.m_BonSrcDecoder.GetSignalLevel();
	Level=(int)(SignalLevel*100.0);
	if (fUDPDriver || (fHDUSDriver && !fNewHDUSDriver)) {
		wsprintf(szText,TEXT("%d.%02d Mbps"),Level/100,Level%100);
	} else {
		// plƍ킹邽߂floatŌvZ
		int BitRate=(int)(((float)DtvEngine.m_BonSrcDecoder.GetBitRate()/
											(float)(1024*1024))*8.0f*100.0f);

		wsprintf(szText,TEXT("%d.%02d db / %d.%02d Mbps"),
								Level/100,Level%100,BitRate/100,BitRate%100);
	}
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CSignalLevelStatusItem::DrawPreview(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,TEXT("52.30 db / 16.73 Mbps"),-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}


class CClockStatusItem : public CStatusItem {
public:
	CClockStatusItem();
	LPCTSTR GetName() const { return TEXT("v"); }
	void Draw(HDC hdc,const RECT *pRect);
	void DrawPreview(HDC hdc,const RECT *pRect);
};

CClockStatusItem::CClockStatusItem() : CStatusItem(STATUS_ITEM_CLOCK,48)
{
}

void CClockStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	SYSTEMTIME st;
	TCHAR szText[64];

	GetLocalTime(&st);
	wsprintf(szText,TEXT("%02d:%02d:%02d"),st.wHour,st.wMinute,st.wSecond);
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CClockStatusItem::DrawPreview(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,TEXT("13:25:30"),-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}


class CProgramInfoStatusItem : public CStatusItem {
	LPTSTR m_pszProgramInfo;
public:
	CProgramInfoStatusItem();
	~CProgramInfoStatusItem();
	LPCTSTR GetName() const { return TEXT("ԑg"); }
	void Draw(HDC hdc,const RECT *pRect);
	void DrawPreview(HDC hdc,const RECT *pRect);
	void OnVisibleChange(bool fVisible);
	bool SetProgramInfo(LPCTSTR pszInfo);
};

CProgramInfoStatusItem::CProgramInfoStatusItem() : CStatusItem(STATUS_ITEM_PROGRAMINFO,256)
{
	m_pszProgramInfo=NULL;
}

CProgramInfoStatusItem::~CProgramInfoStatusItem()
{
	delete [] m_pszProgramInfo;
}

void CProgramInfoStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	if (m_pszProgramInfo!=NULL)
		DrawText(hdc,m_pszProgramInfo,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CProgramInfoStatusItem::DrawPreview(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,TEXT("01:00`01:30 ̃j[X"),-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CProgramInfoStatusItem::OnVisibleChange(bool fVisible)
{
	if (!fVisible) {
		delete [] m_pszProgramInfo;
		m_pszProgramInfo=NULL;
	}
}

bool CProgramInfoStatusItem::SetProgramInfo(LPCTSTR pszInfo)
{
	if (pszInfo!=NULL && lstrcmp(pszInfo,m_pszProgramInfo)==0)
		return true;
	delete [] m_pszProgramInfo;
	if (pszInfo!=NULL)
		m_pszProgramInfo=DuplicateString(pszInfo);
	else
		m_pszProgramInfo=NULL;
	m_pStatus->UpdateItem(m_ID);
	return true;
}




class CVolumeControlItem : public CControlPanelItem {
public:
	CVolumeControlItem();
	void Draw(HDC hdc);
	bool Rayout(int Width,int Height);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
	void OnMouseMove(int x,int y);
};

CVolumeControlItem::CVolumeControlItem()
{
	m_Position.Left=4;
	m_Position.Height=8+4*2;
}

void CVolumeControlItem::Draw(HDC hdc)
{
	HPEN hpen,hpenOld;
	HBRUSH hbr,hbrOld;
	RECT rc;
	COLORREF crBar;

	hpen=CreatePen(PS_SOLID,1,GetTextColor(hdc));
	hpenOld=SelectPen(hdc,hpen);
	hbrOld=SelectBrush(hdc,GetStockObject(NULL_BRUSH));
	GetPosition(&rc);
	rc.left+=4;
	rc.right-=4;
	rc.top+=(rc.bottom-rc.top-8)/2;
	rc.bottom=rc.top+8;
	Rectangle(hdc,rc.left,rc.top,rc.right,rc.bottom);
	SelectBrush(hdc,hbrOld);
	SelectPen(hdc,hpenOld);
	DeleteObject(hpen);
	if (!fMute) {
		crBar=GetTextColor(hdc);
	} else {
		COLORREF crText,crBk;

		crText=GetTextColor(hdc);
		crBk=GetBkColor(hdc);
		crBar=RGB((GetRValue(crText)+GetRValue(crBk))/2,
				  (GetGValue(crText)+GetGValue(crBk))/2,
				  (GetBValue(crText)+GetBValue(crBk))/2);
	}
	hbr=CreateSolidBrush(crBar);
	rc.left+=2;
	rc.top+=2;
	rc.right=rc.left+(rc.right-2-rc.left)*CurrentVolume/MAX_VOLUME;
	rc.bottom-=2;
	FillRect(hdc,&rc,hbr);
	DeleteObject(hbr);
}

bool CVolumeControlItem::Rayout(int Width,int Height)
{
	RECT rc;

	m_pControlPanel->GetItemPosition(CONTROLPANEL_ITEM_VOLUME-1,&rc);
	m_Position.Top=rc.bottom;
	m_Position.Width=Width-4*2;
	return true;
}

void CVolumeControlItem::OnLButtonDown(int x,int y)
{
	OnMouseMove(x,y);
	SetCapture(m_pControlPanel->GetHandle());
}

void CVolumeControlItem::OnRButtonDown(int x,int y)
{
	SendMessage(hwndMain,WM_COMMAND,CM_VOLUME_MUTE,0);
}

void CVolumeControlItem::OnMouseMove(int x,int y)
{
	RECT rc;
	int Volume;

	GetPosition(&rc);
	Volume=(x-(4+2))*100/(rc.right-rc.left-(4+2)*2-1);
	if (Volume<0)
		Volume=0;
	else if (Volume>MAX_VOLUME)
		Volume=MAX_VOLUME;
	if (fMute || Volume!=CurrentVolume)
		SetVolume(Volume,false);
}


class COptionsControlItem : public CControlPanelButton {
public:
	COptionsControlItem();
	bool Rayout(int Width,int Height);
};

COptionsControlItem::COptionsControlItem() :
		CControlPanelButton(CM_OPTIONS,TEXT("ݒ"),4,0,0,0)
{
}

bool COptionsControlItem::Rayout(int Width,int Height)
{
	RECT rc;
	int FontHeight=m_pControlPanel->GetFontHeight();

	m_pControlPanel->GetItemPosition(CONTROLPANEL_ITEM_OPTIONS-1,&rc);
	m_Position.Top=rc.bottom+4;
	m_Position.Width=FontHeight*2+8;
	m_Position.Height=FontHeight+8;
	return true;
}




static void ClearMenu(HMENU hmenu)
{
	int Count,i;

	Count=GetMenuItemCount(hmenu);
	for (i=Count-1;i>=0;i--)
		DeleteMenu(hmenu,i,MF_BYPOSITION);
}


static void SetChannelMenu(HMENU hmenu)
{
	int i;
	TCHAR szText[MAX_CHANNEL_NAME+4];

	ClearMenu(hmenu);
	for (i=0;i<ChannelList.NumChannels();i++) {
		wsprintf(szText,TEXT("%d: %s"),ChannelList.GetChannelNo(i),
													ChannelList.GetName(i));
		AppendMenu(hmenu,MFT_STRING | MFS_ENABLED
				| (i!=0 && i%12==0?MF_MENUBREAK:0),CM_CHANNEL_FIRST+i,szText);
	}
	if (CurrentChannel>=0)
		CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
}


static void SetNetworkRemoconChannelMenu(HMENU hmenu)
{
	const CChannelList &RemoconChList=pNetworkRemocon->GetChannelList();
	int i;
	TCHAR szText[MAX_CHANNEL_NAME+4];

	ClearMenu(hmenu);
	if (RemoconChList.NumChannels()>0) {
		int No,Min,Max;

		Min=1000;
		Max=0;
		for (i=0;i<RemoconChList.NumChannels();i++) {
			No=RemoconChList.GetChannelNo(i);
			if (No<Min)
				Min=No;
			if (No>Max)
				Max=No;
		}
		for (No=Min;No<=Max;No++) {
			for (i=0;i<RemoconChList.NumChannels();i++) {
				if (RemoconChList.GetChannelNo(i)==No) {
					wsprintf(szText,TEXT("%d: %s"),
												No,RemoconChList.GetName(i));
					AppendMenu(hmenu,MFT_STRING | MFS_ENABLED,
											CM_CHANNELNO_FIRST+No-1,szText);
				}
			}
		}
	}
	for (i=0;i<ChannelList.NumChannels();i++) {
		wsprintf(szText,TEXT("%d: %s"),ChannelList.GetChannelNo(i),
													ChannelList.GetName(i));
		AppendMenu(hmenu,MFT_STRING | MFS_ENABLED
			| ((i!=0 && i%12==0) || (i==0 && RemoconChList.NumChannels()>0)?
															MF_MENUBREAK:0),
												CM_CHANNEL_FIRST+i,szText);
	}
	if (CurrentChannel>=0)
		CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
}


static void SetSpaceMenu(HMENU hmenu)
{
	int i;
	LPCTSTR pszName;

	ClearMenu(hmenu);
	NumSpaces=0;
	for (i=0;(pszName=DtvEngine.m_BonSrcDecoder.GetSpaceName(i))!=NULL;i++) {
		AppendMenu(hmenu,MFT_STRING | MFS_ENABLED,CM_SPACE_FIRST+i,pszName);
		NumSpaces++;
	}
	if (NumSpaces>0)
		CheckMenuRadioItem(hmenu,CM_SPACE_FIRST,CM_SPACE_FIRST+NumSpaces-1,
									CM_SPACE_FIRST+CurrentSpace,MF_BYCOMMAND);
}


static void CheckZoomMenu()
{
	int Zoom;
	int i;

	Zoom=CalcZoomRate();
	for (i=0;i<lengthof(ZoomList);i++) {
		CheckMenuItem(hmenuMain,CM_ZOOM_FIRST+i,
				MF_BYCOMMAND | (ZoomList[i]==Zoom?MFS_CHECKED:MFS_UNCHECKED));
	}
}


static void SetVolume(int Volume,bool fOSD)
{
	if (fMute) {
		fMute=false;
		CheckMenuItem(hmenuMain,CM_VOLUME_MUTE,MF_BYCOMMAND | MFS_UNCHECKED);
	}
	DtvEngine.SetVolume(LevelToDeciBel(Volume));
	CurrentVolume=Volume;
	StatusView.UpdateItem(STATUS_ITEM_VOLUME);
	ControlPanel.UpdateItem(CONTROLPANEL_ITEM_VOLUME);
	if (fUseOSD && fOSD) {
		TCHAR szText[64];
		int i;

		szText[0]='\0';
		for (i=0;i<CurrentVolume/5;i++)
			lstrcat(szText,TEXT(""));
		for (;i<20;i++)
			lstrcat(szText,TEXT(""));
		if (!fUsePseudoOSD && DtvEngine.m_MediaViewer.GetVMR9()) {
			LOGFONT lf;
			HFONT hfont;
			RECT rc;

			GetObject(GetStockObject(DEFAULT_GUI_FONT),sizeof(LOGFONT),&lf);
			lf.lfHeight=40;
			lf.lfQuality=NONANTIALIASED_QUALITY;
			hfont=CreateFontIndirect(&lf);
			rc.left=220;
			rc.top=880;
			rc.right=rc.left+400;
			rc.bottom=rc.top+40;
			if (DtvEngine.m_MediaViewer.DrawText(szText,hfont,crOSDTextColor,
																	80,&rc)) {
				if (OSDFadeTime>0)
					SetTimer(hwndMain,TIMER_ID_OSD,OSDFadeTime,NULL);
			}
			DeleteObject(hfont);
		} else {
			SIZE sz;
			RECT rc;

			PseudoOSD.Create(hwndVideoContainer);
			PseudoOSD.SetTextHeight(16);
			PseudoOSD.SetText(szText);
			PseudoOSD.CalcTextSize(&sz);
			GetClientRect(hwndVideoContainer,&rc);
			PseudoOSD.SetPosition(8,rc.bottom-sz.cy-8,sz.cx,sz.cy);
			PseudoOSD.Show(OSDFadeTime);
		}
	}
}




static bool InitNetworkRemocon()
{
	CChannelList List;
	TCHAR szChFilePath[MAX_PATH];

	LoadChannelList(&List,szChannelListFileName);
	List.SetChannelOffset(FIRST_CHANNEL);
	pNetworkRemocon=new CNetworkRemocon;
	GetNetworkRemoconChFilePath(szNetworkRemoconChFile,szChFilePath);
	if (pNetworkRemocon->LoadChannelText(szChFilePath,&List))
		SetNetworkRemoconChannelMenu(GetTopMenu(MENU_POS_CHANNEL));
	pNetworkRemocon->Init(szNetworkRemoconAddress,NetworkRemoconPort);
	return true;
}




static bool ChooseColorDialog(HWND hwndOwner,COLORREF *pcrResult)
{
	CHOOSECOLOR cc;
	static COLORREF crCustomColors[16] = {
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF)
	};

	cc.lStructSize=sizeof(CHOOSECOLOR);
	cc.hwndOwner=hwndOwner;
	cc.hInstance=NULL;
	cc.rgbResult=*pcrResult;
	cc.lpCustColors=crCustomColors;
	cc.Flags=CC_RGBINIT | CC_FULLOPEN;
	if (!ChooseColor(&cc))
		return false;
	*pcrResult=cc.rgbResult;
	return true;
}


static BOOL CALLBACK GeneralOptionsDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		{
			TCHAR szFile[MAX_PATH];
			HANDLE hFind;
			WIN32_FIND_DATA wfd;

			GetModuleFileName(NULL,szFile,lengthof(szFile));
			lstrcpy(PathFindFileName(szFile),TEXT("BonDriver*.dll"));
			hFind=FindFirstFile(szFile,&wfd);
			if (hFind!=INVALID_HANDLE_VALUE) {
				do {
					SendDlgItemMessage(hDlg,IDC_OPTIONS_DRIVER,CB_ADDSTRING,0,
									reinterpret_cast<LPARAM>(wfd.cFileName));
				} while (FindNextFile(hFind,&wfd));
				FindClose(hFind);
			}
			SetDlgItemText(hDlg,IDC_OPTIONS_DRIVER,szDriverFileName);
		}
		{
			CDirectShowUtil DSUtil;
			CStringW FilterName;
			int Sel=-1;

			if (szMpeg2DecoderName[0]=='\0')
				Sel=0;
			SendDlgItemMessage(hDlg,IDC_OPTIONS_DECODER,
									CB_ADDSTRING,0,(LPARAM)TEXT("ftHg"));
			if (DSUtil.FindFilter(&MEDIATYPE_Video,&MEDIASUBTYPE_MPEG2_VIDEO)) {
				for (int i=0;i<DSUtil.GetFilterCount();i++) {
					if (DSUtil.GetFilterInfo(i,NULL,&FilterName)) {
						int Index=SendDlgItemMessage(hDlg,IDC_OPTIONS_DECODER,
							CB_ADDSTRING,0,(LPARAM)(LPCTSTR)FilterName);
						if (FilterName.CompareNoCase(szMpeg2DecoderName)==0)
							Sel=Index;
					}
				}
			}
			SendDlgItemMessage(hDlg,IDC_OPTIONS_DECODER,CB_SETCURSEL,Sel,0);
		}
		CheckDlgButton(hDlg,IDC_OPTIONS_VMR9,fUseVMR9?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_NODESCRAMBLE,
									fNoDescramble?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_USEREMOTECONTROLLER,
								fNoRemoteController?BST_UNCHECKED:BST_CHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_REMOTECONTROLLERACTIVEONLY,
										fNoKeyHook?BST_CHECKED:BST_UNCHECKED);
		EnableDlgItem(hDlg,IDC_OPTIONS_REMOTECONTROLLERACTIVEONLY,
														!fNoRemoteController);
		CheckDlgButton(hDlg,IDC_OPTIONS_NOSCREENSAVER,
									fNoScreenSaver?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_NOMONITORLOWPOWER,
								fNoMonitorLowPower?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_NOMONITORLOWPOWERACTIVEONLY,
					fNoMonitorLowPowerActiveOnly?BST_CHECKED:BST_UNCHECKED);
		EnableDlgItem(hDlg,IDC_OPTIONS_NOMONITORLOWPOWERACTIVEONLY,
														fNoMonitorLowPower);
		CheckDlgButton(hDlg,IDC_OPTIONS_RESTORECHANNEL,
									fRestoreChannel?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_ADJUSTASPECTRESIZING,
							fAdjustAspectResizing?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_SNAPTOWINDOWEDGE,
							fSnapToWindowEdge?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_KEEPSINGLETASK,
									fKeepSingleTask?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_NEWHDUSDRIVER,
									fNewHDUSDriver?BST_CHECKED:BST_UNCHECKED);
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_OPTIONS_USEREMOTECONTROLLER:
			EnableDlgItem(hDlg,IDC_OPTIONS_REMOTECONTROLLERACTIVEONLY,
					IsDlgButtonChecked(hDlg,IDC_OPTIONS_USEREMOTECONTROLLER)==
																BST_CHECKED);
			return TRUE;

		case IDC_OPTIONS_NOMONITORLOWPOWER:
			EnableDlgItem(hDlg,IDC_OPTIONS_NOMONITORLOWPOWERACTIVEONLY,
					IsDlgButtonChecked(hDlg,IDC_OPTIONS_NOMONITORLOWPOWER)==
																BST_CHECKED);
			return TRUE;
		}
		return TRUE;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case PSN_APPLY:
			{
				bool f1,f2;

				GetDlgItemText(hDlg,IDC_OPTIONS_DRIVER,szDriverFileName,
												lengthof(szDriverFileName));
				int Sel=SendDlgItemMessage(hDlg,IDC_OPTIONS_DECODER,
															CB_GETCURSEL,0,0);
				if (Sel>0)
					SendDlgItemMessage(hDlg,IDC_OPTIONS_DECODER,CB_GETLBTEXT,
											Sel,(LPARAM)szMpeg2DecoderName);
				else
					szMpeg2DecoderName[0]='\0';
				fUseVMR9=IsDlgButtonChecked(hDlg,IDC_OPTIONS_VMR9)==BST_CHECKED;
				fNoDescramble=IsDlgButtonChecked(hDlg,IDC_OPTIONS_NODESCRAMBLE)
																==BST_CHECKED;
				f1=IsDlgButtonChecked(hDlg,
							IDC_OPTIONS_USEREMOTECONTROLLER)==BST_UNCHECKED;
				f2=IsDlgButtonChecked(hDlg,
						IDC_OPTIONS_REMOTECONTROLLERACTIVEONLY)==BST_CHECKED;
				if (f1!=fNoRemoteController || f2!=fNoKeyHook) {
					if (f1 || f2) {
						if (pRemoteController!=NULL) {
							delete pRemoteController;
							pRemoteController=NULL;
						}
					} else {
						if (pRemoteController==NULL) {
							pRemoteController=new CRemoteController(hwndMain);
							pRemoteController->BeginHook();
						}
					}
					if (f1) {
						hAccel=NULL;
					} else {
						hAccel=LoadAccelerators(hInst,
									MAKEINTRESOURCE(f2?IDA_ACCEL:IDA_ACCEL2));
					}
					fNoRemoteController=f1;
					fNoKeyHook=f2;
				}
				fNoScreenSaver=IsDlgButtonChecked(hDlg,
									IDC_OPTIONS_NOSCREENSAVER)==BST_CHECKED;
				fNoMonitorLowPower=IsDlgButtonChecked(hDlg,
								IDC_OPTIONS_NOMONITORLOWPOWER)==BST_CHECKED;
				fNoMonitorLowPowerActiveOnly=IsDlgButtonChecked(hDlg,
						IDC_OPTIONS_NOMONITORLOWPOWERACTIVEONLY)==BST_CHECKED;
				SetDisplayStatus();
				fRestoreChannel=IsDlgButtonChecked(hDlg,
									IDC_OPTIONS_RESTORECHANNEL)==BST_CHECKED;
				fAdjustAspectResizing=IsDlgButtonChecked(hDlg,
								IDC_OPTIONS_ADJUSTASPECTRESIZING)==BST_CHECKED;
				fSnapToWindowEdge=IsDlgButtonChecked(hDlg,
									IDC_OPTIONS_SNAPTOWINDOWEDGE)==BST_CHECKED;
				fKeepSingleTask=IsDlgButtonChecked(hDlg,
									IDC_OPTIONS_KEEPSINGLETASK)==BST_CHECKED;
				fNewHDUSDriver=IsDlgButtonChecked(hDlg,
									IDC_OPTIONS_NEWHDUSDRIVER)==BST_CHECKED;
			}
			return TRUE;
		}
		break;
	}
	return FALSE;
}


static BOOL CALLBACK ViewOptionsDlgProc(HWND hDlg,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	static COLORREF crStatusBack,crStatusText;
	static COLORREF crStatusHighlightBack,crStatusHighlightText;
	static COLORREF crInfoBack,crInfoText;
	static COLORREF crOSDText;

	switch (uMsg) {
	case WM_INITDIALOG:
		crStatusBack=crStatusBackColor;
		crStatusText=crStatusTextColor;
		crStatusHighlightBack=crStatusHighlightBackColor;
		crStatusHighlightText=crStatusHighlightTextColor;
		crInfoBack=crInfoBackColor;
		crInfoText=crInfoTextColor;
		CheckDlgButton(hDlg,IDC_OPTIONS_USEOSD,
									fUseOSD?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_PSEUDOOSD,
									fUsePseudoOSD?BST_CHECKED:BST_UNCHECKED);
		crOSDText=crOSDTextColor;
		SetDlgItemInt(hDlg,IDC_OPTIONS_OSDFADETIME,OSDFadeTime/1000,FALSE);
		SendDlgItemMessage(hDlg,IDC_OPTIONS_OSDFADETIME_UD,UDM_SETRANGE,0,
													MAKELPARAM(UD_MAXVAL,1));
		EnableDlgItems(hDlg,IDC_OPTIONS_OSD_FIRST,IDC_OPTIONS_OSD_LAST,
																	fUseOSD);
		CheckDlgButton(hDlg,IDC_OPTIONS_CLIENTEDGE,
									fClientEdge?BST_CHECKED:BST_UNCHECKED);
		return TRUE;

	case WM_DRAWITEM:
		{
			LPDRAWITEMSTRUCT pdis=(LPDRAWITEMSTRUCT)lParam;
			COLORREF cr;
			HBRUSH hbr;
			RECT rc;

			switch (pdis->CtlID) {
			case IDC_OPTIONS_STATUSBACKCOLOR:	cr=crStatusBack;	break;
			case IDC_OPTIONS_STATUSTEXTCOLOR:	cr=crStatusText;	break;
			case IDC_OPTIONS_STATUSHIGHLIGHTBACKCOLOR:
				cr=crStatusHighlightBack;	break;
			case IDC_OPTIONS_STATUSHIGHLIGHTTEXTCOLOR:
				cr=crStatusHighlightText;	break;
			case IDC_OPTIONS_INFOBACKCOLOR:		cr=crInfoBack;		break;
			case IDC_OPTIONS_INFOTEXTCOLOR:		cr=crInfoText;		break;
			case IDC_OPTIONS_OSDTEXTCOLOR:		cr=crOSDText;		break;
			}
			hbr=CreateSolidBrush(cr);
			rc=pdis->rcItem;
			DrawEdge(pdis->hDC,&rc,BDR_SUNKENOUTER,BF_RECT | BF_ADJUST);
			FillRect(pdis->hDC,&rc,hbr);
			DeleteObject(hbr);
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_OPTIONS_STATUSBACKCOLOR:
			if (ChooseColorDialog(hDlg,&crStatusBack))
				InvalidateRect(GetDlgItem(hDlg,IDC_OPTIONS_STATUSBACKCOLOR),
																	NULL,TRUE);
			return TRUE;

		case IDC_OPTIONS_STATUSTEXTCOLOR:
			if (ChooseColorDialog(hDlg,&crStatusText))
				InvalidateRect(GetDlgItem(hDlg,IDC_OPTIONS_STATUSTEXTCOLOR),
																	NULL,TRUE);
			return TRUE;

		case IDC_OPTIONS_STATUSHIGHLIGHTBACKCOLOR:
			if (ChooseColorDialog(hDlg,&crStatusHighlightBack))
				InvalidateRect(GetDlgItem(hDlg,
							IDC_OPTIONS_STATUSHIGHLIGHTBACKCOLOR),NULL,TRUE);
			return TRUE;

		case IDC_OPTIONS_STATUSHIGHLIGHTTEXTCOLOR:
			if (ChooseColorDialog(hDlg,&crStatusHighlightText))
				InvalidateRect(GetDlgItem(hDlg,
							IDC_OPTIONS_STATUSHIGHLIGHTTEXTCOLOR),NULL,TRUE);
			return TRUE;

		case IDC_OPTIONS_INFOBACKCOLOR:
			if (ChooseColorDialog(hDlg,&crInfoBack))
				InvalidateRect(GetDlgItem(hDlg,IDC_OPTIONS_INFOBACKCOLOR),
																	NULL,TRUE);
			return TRUE;

		case IDC_OPTIONS_INFOTEXTCOLOR:
			if (ChooseColorDialog(hDlg,&crInfoText))
				InvalidateRect(GetDlgItem(hDlg,IDC_OPTIONS_INFOTEXTCOLOR),
																	NULL,TRUE);
			return TRUE;

		case IDC_OPTIONS_USEOSD:
			EnableDlgItems(hDlg,IDC_OPTIONS_OSD_FIRST,IDC_OPTIONS_OSD_LAST,
					IsDlgButtonChecked(hDlg,IDC_OPTIONS_USEOSD)==BST_CHECKED);
			return TRUE;

		case IDC_OPTIONS_OSDTEXTCOLOR:
			if (ChooseColorDialog(hDlg,&crOSDText))
				InvalidateRect(GetDlgItem(hDlg,IDC_OPTIONS_OSDTEXTCOLOR),
																	NULL,TRUE);
			return TRUE;
		}
		return TRUE;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case PSN_APPLY:
			{
				crStatusBackColor=crStatusBack;
				crStatusTextColor=crStatusText;
				crStatusHighlightBackColor=crStatusHighlightBack;
				crStatusHighlightTextColor=crStatusHighlightText;
				StatusView.SetColor(crStatusBackColor,crStatusTextColor,
						crStatusHighlightBackColor,crStatusHighlightTextColor);
				if (crInfoBackColor!=crInfoBack || crInfoTextColor!=crInfoText) {
					crInfoBackColor=crInfoBack;
					crInfoTextColor=crInfoText;
					InfoWindow.SetColor(crInfoBackColor,crInfoTextColor);
					ProgramListView.SetColors(crInfoBackColor,crInfoTextColor,
											crInfoTextColor,crInfoBackColor);
				}
				fUseOSD=
					IsDlgButtonChecked(hDlg,IDC_OPTIONS_USEOSD)==BST_CHECKED;
				fUsePseudoOSD=
					IsDlgButtonChecked(hDlg,IDC_OPTIONS_PSEUDOOSD)==BST_CHECKED;
				crOSDTextColor=crOSDText;
				OSDFadeTime=GetDlgItemInt(hDlg,IDC_OPTIONS_OSDFADETIME,NULL,
																FALSE)*1000;
				bool fEdge=IsDlgButtonChecked(hDlg,IDC_OPTIONS_CLIENTEDGE)==
																BST_CHECKED;
				if (fEdge!=fClientEdge) {
					DWORD ExStyle;

					fClientEdge=fEdge;
					ExStyle=GetWindowLong(hwndView,GWL_EXSTYLE);
					ExStyle^=WS_EX_CLIENTEDGE;
					SetWindowLong(hwndView,GWL_EXSTYLE,ExStyle);
					SetWindowPos(hwndView,NULL,0,0,0,0,
						SWP_NOZORDER | SWP_NOMOVE | SWP_NOSIZE |
											SWP_FRAMECHANGED | SWP_DRAWFRAME);
				}
			}
			break;
		}
	}
	return FALSE;
}


static BOOL CALLBACK OperationOptionsDlgProc(HWND hDlg,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		{
			static const LPCTSTR pszWheelMode[] = {
				TEXT("Ȃ"),TEXT(""),TEXT("`l")
			};
			int i;

			for (i=0;i<lengthof(pszWheelMode);i++)
				SendDlgItemMessage(hDlg,IDC_OPTIONS_WHEELMODE,CB_ADDSTRING,0,
									reinterpret_cast<LPARAM>(pszWheelMode[i]));
			SendDlgItemMessage(hDlg,IDC_OPTIONS_WHEELMODE,CB_SETCURSEL,
																WheelMode,0);
			for (i=0;i<lengthof(pszWheelMode);i++)
				SendDlgItemMessage(hDlg,IDC_OPTIONS_WHEELSHIFTMODE,CB_ADDSTRING,
								0,reinterpret_cast<LPARAM>(pszWheelMode[i]));
			SendDlgItemMessage(hDlg,IDC_OPTIONS_WHEELSHIFTMODE,CB_SETCURSEL,
															WheelShiftMode,0);
			CheckDlgButton(hDlg,IDC_OPTIONS_WHEELCHANNELREVERSE,
							fWheelChannelReverse?BST_CHECKED:BST_UNCHECKED);
			SetDlgItemInt(hDlg,IDC_OPTIONS_WHEELCHANNELDELAY,
													WheelChannelDelay,FALSE);
			CheckDlgButton(hDlg,IDC_OPTIONS_CHANGECH_FUNCTION,
						fFunctionKeyChangeChannel?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(hDlg,IDC_OPTIONS_CHANGECH_DIGIT,
						fDigitKeyChangeChannel?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(hDlg,IDC_OPTIONS_CHANGECH_NUMPAD,
						fNumPadChangeChannel?BST_CHECKED:BST_UNCHECKED);
		}
		return TRUE;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case PSN_APPLY:
			{
				WheelMode=SendDlgItemMessage(hDlg,IDC_OPTIONS_WHEELMODE,
															CB_GETCURSEL,0,0);
				WheelShiftMode=SendDlgItemMessage(hDlg,
								IDC_OPTIONS_WHEELSHIFTMODE,CB_GETCURSEL,0,0);
				fWheelChannelReverse=IsDlgButtonChecked(hDlg,
								IDC_OPTIONS_WHEELCHANNELREVERSE)==BST_CHECKED;
				WheelChannelDelay=GetDlgItemInt(hDlg,
									IDC_OPTIONS_WHEELCHANNELDELAY,NULL,FALSE);
				fFunctionKeyChangeChannel=IsDlgButtonChecked(hDlg,
								IDC_OPTIONS_CHANGECH_FUNCTION)==BST_CHECKED;
				fDigitKeyChangeChannel=IsDlgButtonChecked(hDlg,
									IDC_OPTIONS_CHANGECH_DIGIT)==BST_CHECKED;
				fNumPadChangeChannel=IsDlgButtonChecked(hDlg,
									IDC_OPTIONS_CHANGECH_NUMPAD)==BST_CHECKED;
			}
			break;
		}
		break;
	}
	return FALSE;
}


static BOOL CALLBACK RecordOptionsDlgProc(HWND hDlg,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		SetDlgItemText(hDlg,IDC_RECORDOPTIONS_SAVEFOLDER,szRecordSaveFolder);
		SetDlgItemText(hDlg,IDC_RECORDOPTIONS_FILENAME,szRecordFileName);
		CheckDlgButton(hDlg,IDC_RECORDOPTIONS_ADDTIME,
						fAddRecordTime?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_RECORDOPTIONS_CONFIRMCHANNELCHANGE,
						fConfirmRecChannelChange?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_RECORDOPTIONS_CONFIRMEXIT,
						fConfirmRecordingExit?BST_CHECKED:BST_UNCHECKED);
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_RECORDOPTIONS_SAVEFOLDER_BROWSE:
			{
				TCHAR szFolder[MAX_PATH];

				GetDlgItemText(hDlg,IDC_RECORDOPTIONS_SAVEFOLDER,szFolder,
																	MAX_PATH);
				if (BrowseFolderDialog(hDlg,szFolder,
										TEXT("^t@C̕ۑtH_:")))
					SetDlgItemText(hDlg,IDC_RECORDOPTIONS_SAVEFOLDER,szFolder);
			}
			return TRUE;
		}
		return TRUE;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case PSN_APPLY:
			GetDlgItemText(hDlg,IDC_RECORDOPTIONS_SAVEFOLDER,
							szRecordSaveFolder,lengthof(szRecordSaveFolder));
			if (!PathIsDirectory(szRecordSaveFolder)) {
				TCHAR szMessage[MAX_PATH+64];

				PropSheet_SetCurSelByID(((LPNMHDR)lParam)->hwndFrom,IDD_OPTIONS_RECORD);
				wsprintf(szMessage,
					TEXT("ۑtH_ \"%s\" ܂B\r\n")
					TEXT("쐬܂?"),szRecordSaveFolder);
				if (MessageBox(hDlg,szMessage,TEXT("tH_쐬̊mF"),
										MB_YESNO | MB_ICONQUESTION)==IDYES) {
					int Result;

					Result=SHCreateDirectoryEx(hDlg,szRecordSaveFolder,NULL);
					if (Result!=ERROR_SUCCESS && Result!=ERROR_ALREADY_EXISTS)
						MessageBox(hDlg,TEXT("tH_쐬ł܂B"),
											NULL,MB_OK | MB_ICONEXCLAMATION);
				}
			}
			GetDlgItemText(hDlg,IDC_RECORDOPTIONS_FILENAME,
								szRecordFileName,lengthof(szRecordFileName));
			fAddRecordTime=IsDlgButtonChecked(hDlg,
									IDC_RECORDOPTIONS_ADDTIME)==BST_CHECKED;
			fConfirmRecChannelChange=IsDlgButtonChecked(hDlg,
							IDC_RECORDOPTIONS_CONFIRMCHANNELCHANGE)==BST_CHECKED;
			fConfirmRecordingExit=IsDlgButtonChecked(hDlg,
							IDC_RECORDOPTIONS_CONFIRMEXIT)==BST_CHECKED;
			break;
		}
		break;
	}
	return FALSE;
}


void SyncTrackBar(HWND hDlg,int nEditID,int nTrackbarID)
{
	int nMin,nMax,nVal;

	nMin=(int)SendDlgItemMessage(hDlg,nTrackbarID,TBM_GETRANGEMIN,0,0);
	nMax=(int)SendDlgItemMessage(hDlg,nTrackbarID,TBM_GETRANGEMAX,0,0);
	nVal=GetDlgItemInt(hDlg,nEditID,NULL,TRUE);
	SendDlgItemMessage(hDlg,nTrackbarID,TBM_SETPOS,TRUE,
										nVal<nMin?nMin:nVal>nMax?nMax:nVal);
}


void SyncEditControl(HWND hDlg,int nTrackbarID,int nEditID)
{
	int nVal;

	nVal=(int)SendDlgItemMessage(hDlg,nTrackbarID,TBM_GETPOS,0,0);
	SetDlgItemInt(hDlg,nEditID,nVal,TRUE);
}


static BOOL CALLBACK CaptureOptionsDlgProc(HWND hDlg,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		{
			int i;
			LPCTSTR pszFormat;

			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_SAVEFOLDER,EM_LIMITTEXT,
																MAX_PATH-1,0);
			SetDlgItemText(hDlg,IDC_CAPTUREOPTIONS_SAVEFOLDER,
														szCaptureSaveFolder);
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_FILENAME,EM_LIMITTEXT,
																MAX_PATH-1,0);
			SetDlgItemText(hDlg,IDC_CAPTUREOPTIONS_FILENAME,szCaptureFileName);
			for (i=0;(pszFormat=ImageCodec.EnumSaveFormat(i))!=NULL;i++)
				SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_FORMAT,CB_ADDSTRING,
										0,reinterpret_cast<LPARAM>(pszFormat));
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_FORMAT,CB_SETCURSEL,
														CaptureSaveFormat,0);
			// JPEG quality
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_TB,
										TBM_SETRANGE,TRUE,MAKELPARAM(0,100));
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_TB,
												TBM_SETPOS,TRUE,JPEGQuality);
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_TB,
														TBM_SETPAGESIZE,0,10);
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_TB,
														TBM_SETTICFREQ,10,0);
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_EDIT,
															EM_LIMITTEXT,3,0);
			SetDlgItemInt(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_EDIT,
															JPEGQuality,TRUE);
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_UD,
											UDM_SETRANGE,0,MAKELPARAM(100,0));
			// PNG compression level
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_TB,
											TBM_SETRANGE,TRUE,MAKELPARAM(0,9));
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_TB,
										TBM_SETPOS,TRUE,PNGCompressionLevel);
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_TB,
														TBM_SETPAGESIZE,0,1);
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_TB,
														TBM_SETTICFREQ,1,0);
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_EDIT,
															EM_LIMITTEXT,0,1);
			SetDlgItemInt(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_EDIT,
													PNGCompressionLevel,FALSE);
			SendDlgItemMessage(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_UD,
											UDM_SETRANGE,0,MAKELPARAM(9,0));
			CheckDlgButton(hDlg,IDC_CAPTUREOPTIONS_ICONSAVEFILE,
							fCaptureIconSaveToFile?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(hDlg,IDC_CAPTUREOPTIONS_SETCOMMENT,
							fCaptureSetComment?BST_CHECKED:BST_UNCHECKED);
		}
		return TRUE;

	case WM_HSCROLL:
		if (reinterpret_cast<HWND>(lParam)==
						GetDlgItem(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_TB)) {
			SyncEditControl(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_TB,
										IDC_CAPTUREOPTIONS_JPEGQUALITY_EDIT);
		} else if (reinterpret_cast<HWND>(lParam)==
						GetDlgItem(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_TB)) {
			SyncEditControl(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_TB,
											IDC_CAPTUREOPTIONS_PNGLEVEL_EDIT);
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_CAPTUREOPTIONS_SAVEFOLDER_BROWSE:
			{
				TCHAR szFolder[MAX_PATH];

				GetDlgItemText(hDlg,IDC_CAPTUREOPTIONS_SAVEFOLDER,szFolder,
																	MAX_PATH);
				if (BrowseFolderDialog(hDlg,szFolder,
												TEXT("摜̕ۑtH_:")))
					SetDlgItemText(hDlg,IDC_CAPTUREOPTIONS_SAVEFOLDER,szFolder);
			}
			return TRUE;

		case IDC_CAPTUREOPTIONS_JPEGQUALITY_EDIT:
			if (HIWORD(wParam)==EN_CHANGE)
				SyncTrackBar(hDlg,IDC_CAPTUREOPTIONS_JPEGQUALITY_EDIT,
											IDC_CAPTUREOPTIONS_JPEGQUALITY_TB);
			return TRUE;

		case IDC_CAPTUREOPTIONS_PNGLEVEL_EDIT:
			if (HIWORD(wParam)==EN_CHANGE)
				SyncTrackBar(hDlg,IDC_CAPTUREOPTIONS_PNGLEVEL_EDIT,
											IDC_CAPTUREOPTIONS_PNGLEVEL_TB);
			return TRUE;
		}
		return TRUE;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case PSN_APPLY:
			{
				GetDlgItemText(hDlg,IDC_CAPTUREOPTIONS_SAVEFOLDER,
							szCaptureSaveFolder,lengthof(szCaptureSaveFolder));
				GetDlgItemText(hDlg,IDC_CAPTUREOPTIONS_FILENAME,
								szCaptureFileName,lengthof(szCaptureFileName));
				CaptureSaveFormat=SendDlgItemMessage(hDlg,
							IDC_CAPTUREOPTIONS_FORMAT,CB_GETCURSEL,0,0);
				JPEGQuality=SendDlgItemMessage(hDlg,
							IDC_CAPTUREOPTIONS_JPEGQUALITY_TB,TBM_GETPOS,0,0);
				PNGCompressionLevel=SendDlgItemMessage(hDlg,
							IDC_CAPTUREOPTIONS_PNGLEVEL_TB,TBM_GETPOS,0,0);
				fCaptureIconSaveToFile=IsDlgButtonChecked(hDlg,
								IDC_CAPTUREOPTIONS_ICONSAVEFILE)==BST_CHECKED;
				fCaptureSetComment=IsDlgButtonChecked(hDlg,
								IDC_CAPTUREOPTIONS_SETCOMMENT)==BST_CHECKED;
			}
			break;
		}
		break;
	}
	return FALSE;
}


static BOOL CALLBACK NetworkRemoconOptionsDlgProc(HWND hDlg,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		CheckDlgButton(hDlg,IDC_NETWORKREMOCON_USE,
								fUseNetworkRemocon?BST_CHECKED:BST_UNCHECKED);
		SetDlgItemTextA(hDlg,IDC_NETWORKREMOCON_ADDRESS,szNetworkRemoconAddress);
		SetDlgItemInt(hDlg,IDC_NETWORKREMOCON_PORT,NetworkRemoconPort,FALSE);
		SetDlgItemText(hDlg,IDC_NETWORKREMOCON_CHANNELFILE,
													szNetworkRemoconChFile);
		return TRUE;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case PSN_APPLY:
			{
				bool fUse;
				char szAddress[16];
				unsigned int Port;
				TCHAR szChannelFile[MAX_PATH];

				fUse=IsDlgButtonChecked(hDlg,IDC_NETWORKREMOCON_USE)==
																BST_CHECKED;
				GetDlgItemTextA(hDlg,IDC_NETWORKREMOCON_ADDRESS,szAddress,
														lengthof(szAddress));
				Port=GetDlgItemInt(hDlg,IDC_NETWORKREMOCON_PORT,NULL,FALSE);
				GetDlgItemText(hDlg,IDC_NETWORKREMOCON_CHANNELFILE,
										szChannelFile,lengthof(szChannelFile));
				if (fUse!=fUseNetworkRemocon) {
					fUseNetworkRemocon=fUse;
					if (fUse) {
						if (fUDPDriver && pNetworkRemocon==NULL) {
							NetworkRemoconPort=Port;
							lstrcpyA(szNetworkRemoconAddress,szAddress);
							lstrcpy(szNetworkRemoconChFile,szChannelFile);
							InitNetworkRemocon();
						}
					} else if (pNetworkRemocon!=NULL) {
						delete pNetworkRemocon;
						pNetworkRemocon=NULL;
						SetChannelMenu(GetTopMenu(MENU_POS_CHANNEL));
					}
				} else {
					if (fUseNetworkRemocon
							&& (NetworkRemoconPort!=Port
								|| lstrcmpiA(szNetworkRemoconAddress,szAddress)!=0)) {
						pNetworkRemocon->Init(szAddress,Port);
					}
					if (lstrcmpi(szNetworkRemoconChFile,szChannelFile)!=0) {
						CChannelList List;
						TCHAR szChannelFilePath[MAX_PATH];

						LoadChannelList(&List,szChannelListFileName);
						List.SetChannelOffset(FIRST_CHANNEL);
						GetNetworkRemoconChFilePath(szChannelFile,
															szChannelFilePath);
						pNetworkRemocon=new CNetworkRemocon;
						pNetworkRemocon->LoadChannelText(szChannelFile,&List);
						SetNetworkRemoconChannelMenu(
												GetTopMenu(MENU_POS_CHANNEL));
					}
				}
				NetworkRemoconPort=Port;
				lstrcpyA(szNetworkRemoconAddress,szAddress);
				lstrcpy(szNetworkRemoconChFile,szChannelFile);
			}
			return TRUE;
		}
		break;
	}
	return FALSE;
}


BOOL CALLBACK OptionsDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static const struct {
		LPCTSTR pszTitle;
		LPCTSTR pszTemplate;
		DLGPROC pfnDlgProc;
		void *pParam;
		COLORREF crTitleColor;
	} PageList[] = {
		{TEXT(""),			MAKEINTRESOURCE(IDD_OPTIONS_GENERAL),
			GeneralOptionsDlgProc,			NULL,			RGB(128,0,0)},
		{TEXT("\"),			MAKEINTRESOURCE(IDD_OPTIONS_VIEW),
			ViewOptionsDlgProc,				NULL,			RGB(0,128,0)},
		{TEXT("Xe[^Xo["),MAKEINTRESOURCE(IDD_OPTIONS_STATUS),
			CStatusOptions::DlgProc,		&StatusOptions,	RGB(0,0,128)},
		{TEXT(""),			MAKEINTRESOURCE(IDD_OPTIONS_OPERATION),
			OperationOptionsDlgProc,		NULL,			RGB(128,128,0)},
		{TEXT("^"),			MAKEINTRESOURCE(IDD_OPTIONS_RECORD),
			RecordOptionsDlgProc,			NULL,			RGB(128,0,128)},
		{TEXT("Lv`"),	MAKEINTRESOURCE(IDD_OPTIONS_CAPTURE),
			CaptureOptionsDlgProc,			NULL,			RGB(0,128,128)},
		{TEXT("lbg[NR"),MAKEINTRESOURCE(IDD_OPTIONS_NETWORKREMOCON),
			NetworkRemoconOptionsDlgProc,	NULL,			RGB(255,128,0)},
	};
	static HWND hDlgList[lengthof(PageList)];
	static int CurPage=0;
	static HFONT hfontTitle;

	switch (uMsg) {
	case WM_INITDIALOG:
		{
			int i;
			RECT rc;
			POINT pt;

			for (i=0;i<lengthof(PageList);i++) {
				hDlgList[i]=NULL;
				SendDlgItemMessage(hDlg,IDC_OPTIONS_LIST,LB_ADDSTRING,0,
							reinterpret_cast<LPARAM>(PageList[i].pszTitle));
			}
			if ((int)lParam>=0 && (int)lParam<(int)lengthof(PageList))
				CurPage=lParam;
			hDlgList[CurPage]=CreateDialogParam(hInst,
				PageList[CurPage].pszTemplate,hDlg,
				PageList[CurPage].pfnDlgProc,(LPARAM)PageList[CurPage].pParam);
			GetWindowRect(GetDlgItem(hDlg,IDC_OPTIONS_PAGEPLACE),&rc);
			pt.x=rc.left;
			pt.y=rc.top;
			ScreenToClient(hDlg,&pt);
			SetWindowPos(hDlgList[CurPage],NULL,pt.x,pt.y,0,0,
													SWP_NOZORDER | SWP_NOSIZE);
			ShowWindow(hDlgList[CurPage],SW_SHOW);
			SendDlgItemMessage(hDlg,IDC_OPTIONS_LIST,LB_SETCURSEL,CurPage,0);
		}
		{
			HFONT hfont;
			LOGFONT lf;

			hfont=(HFONT)SendMessage(hDlg,WM_GETFONT,0,0);
			GetObject(hfont,sizeof(LOGFONT),&lf);
			lf.lfWeight=FW_BOLD;
			hfontTitle=CreateFontIndirect(&lf);
		}
		return TRUE;

	case WM_DRAWITEM:
		{
			LPDRAWITEMSTRUCT pdis=(LPDRAWITEMSTRUCT)lParam;
			HPEN hpen,hpenOld;
			int i;
			int nMax,nValue;
			COLORREF cr;
			HFONT hfontOld;
			COLORREF crOldText;
			int nOldBkMode;
			RECT rc;

			hpenOld=(HPEN)GetCurrentObject(pdis->hDC,OBJ_PEN);
			nMax=pdis->rcItem.right-pdis->rcItem.left-1;
			for (i=pdis->rcItem.left;i<pdis->rcItem.right;i++) {
				nValue=(i-pdis->rcItem.left)*255/nMax;
				cr=RGB(GetRValue(PageList[CurPage].crTitleColor)*nValue/255,
					   GetGValue(PageList[CurPage].crTitleColor)*nValue/255,
					   GetBValue(PageList[CurPage].crTitleColor)*nValue/255);
				hpen=CreatePen(PS_SOLID,1,cr);
				SelectObject(pdis->hDC,hpen);
				MoveToEx(pdis->hDC,i,pdis->rcItem.top,NULL);
				LineTo(pdis->hDC,i,pdis->rcItem.bottom);
				SelectObject(pdis->hDC,hpenOld);
				DeleteObject(hpen);
			}
			hfontOld=(HFONT)SelectObject(pdis->hDC,hfontTitle);
			crOldText=SetTextColor(pdis->hDC,RGB(255,255,255));
			nOldBkMode=SetBkMode(pdis->hDC,TRANSPARENT);
			rc.left=pdis->rcItem.left+2;
			rc.top=pdis->rcItem.top;
			rc.right=pdis->rcItem.right-2;
			rc.bottom=pdis->rcItem.bottom;
			DrawText(pdis->hDC,PageList[CurPage].pszTitle,-1,&rc,
						DT_LEFT | DT_VCENTER | DT_SINGLELINE | DT_NOPREFIX);
			SelectObject(pdis->hDC,hfontOld);
			SetTextColor(pdis->hDC,crOldText);
			SetBkMode(pdis->hDC,nOldBkMode);
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_OPTIONS_LIST:
			if (HIWORD(wParam)==LBN_SELCHANGE) {
				int NewPage=SendDlgItemMessage(hDlg,IDC_OPTIONS_LIST,LB_GETCURSEL,0,0);

				if (hDlgList[NewPage]==NULL) {
					HCURSOR hcurOld;
					RECT rc;
					POINT pt;

					hcurOld=SetCursor(LoadCursor(NULL,IDC_WAIT));
					hDlgList[NewPage]=CreateDialogParam(hInst,
											PageList[NewPage].pszTemplate,hDlg,
											PageList[NewPage].pfnDlgProc,
											(LPARAM)PageList[NewPage].pParam);
					GetWindowRect(GetDlgItem(hDlg,IDC_OPTIONS_PAGEPLACE),&rc);
					pt.x=rc.left;
					pt.y=rc.top;
					ScreenToClient(hDlg,&pt);
					SetWindowPos(hDlgList[NewPage],NULL,pt.x,pt.y,0,0,
													SWP_NOZORDER | SWP_NOSIZE);
					SetCursor(hcurOld);
				}
				ShowWindow(hDlgList[CurPage],SW_HIDE);
				ShowWindow(hDlgList[NewPage],SW_SHOW);
				CurPage=NewPage;
				InvalidateRect(GetDlgItem(hDlg,IDC_OPTIONS_TITLE),NULL,TRUE);
			}
			return TRUE;
		case IDOK:
		case IDCANCEL:
			{
				HCURSOR hcurOld;
				NMHDR nmh;
				int i;

				hcurOld=SetCursor(LoadCursor(NULL,IDC_WAIT));
				nmh.code=LOWORD(wParam)==IDOK?PSN_APPLY:PSN_RESET;
				for (i=0;i<lengthof(PageList);i++) {
					if (hDlgList[i]!=NULL)
						SendMessage(hDlgList[i],WM_NOTIFY,0,(LPARAM)&nmh);
				}
				SetCursor(hcurOld);
				EndDialog(hDlg,LOWORD(wParam));
			}
			return TRUE;
		}
		return TRUE;

	case WM_DESTROY:
		DeleteObject(hfontTitle);
		return TRUE;
	}
	return FALSE;
}


enum {
	OPTIONS_PAGE_GENERAL,
	OPTIONS_PAGE_VIEW,
	OPTIONS_PAGE_STATUS,
	OPTIONS_PAGE_OPERATION,
	OPTIONS_PAGE_RECORD,
	OPTIONS_PAGE_CAPTURE,
	OPTIONS_PAGE_NETWORKREMOCON
};


static bool OptionsDialog(HWND hwndOwner,int StartPage=-1)
{
	return DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_OPTIONS),hwndOwner,
											OptionsDlgProc,StartPage)==IDOK;
}




static void AdjustWindowSize(int Width,int Height)
{
	RECT rc;

	if (IsZoomed(hwndMain))
		return;
	GetWindowRect(hwndView,&rc);
	rc.right=rc.left+Width;
	rc.bottom=rc.top+Height;
	if (fClientEdge) {
		rc.right+=GetSystemMetrics(SM_CXEDGE)*2;
		rc.bottom+=GetSystemMetrics(SM_CYEDGE)*2;
	}
	if (fShowStatusBar)
		rc.bottom+=StatusView.Height();
	AdjustWindowRectEx(&rc,GetWindowStyle(hwndMain),FALSE,
												GetWindowExStyle(hwndMain));
	MoveWindow(hwndMain,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,TRUE);
}


static void SetZoomRate(int Zoom)
{
	WORD Width,Height;

	if (DtvEngine.m_MediaViewer.GetCroppedVideoSize(&Width,&Height)) {
		int w,h;
		BYTE XAspect,YAspect;

		PanAndScanVideoWidth=w=Width;
		PanAndScanVideoHeight=h=Height;
		if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(&XAspect,&YAspect))
			AdjustAspect(&w,&h,XAspect,YAspect);
		AdjustWindowSize(w*Zoom/100,h*Zoom/100);
	}
}


static void ShowChannelOSD()
{
	ChannelInfo Info;
	bool fOK;
	TCHAR szText[4+MAX_CHANNEL_NAME];

	if (fWheelChannelChanging)
		fOK=GetChangingChannelInfo(&Info);
	else
		fOK=GetCurrentChannelInfo(&Info);
	if (fOK) {
		wsprintf(szText,TEXT("%d"),Info.ChannelNo);
		if (!fUsePseudoOSD && DtvEngine.m_MediaViewer.GetVMR9()) {
			LOGFONT lf;
			HFONT hfont;
			RECT rc;

			GetObject(GetStockObject(DEFAULT_GUI_FONT),
											sizeof(LOGFONT),&lf);
			lf.lfHeight=80;
			lf.lfQuality=NONANTIALIASED_QUALITY;
			hfont=CreateFontIndirect(&lf);
			rc.left=200;
			rc.top=120;
			rc.right=rc.left+80;
			rc.bottom=rc.top+100;
			if (DtvEngine.m_MediaViewer.DrawText(szText,hfont,
										crOSDTextColor,80,&rc)) {
				if (OSDFadeTime>0)
					SetTimer(hwndMain,TIMER_ID_OSD,OSDFadeTime,NULL);
			}
			DeleteObject(hfont);
		} else {
			SIZE sz;
			COLORREF cr;

			wsprintf(szText+lstrlen(szText),TEXT(" %s"),Info.szName);
			PseudoOSD.Create(hwndVideoContainer);
			PseudoOSD.SetTextHeight(32);
			PseudoOSD.SetText(szText);
			PseudoOSD.CalcTextSize(&sz);
			if (fWheelChannelChanging)
				cr=RGB(GetRValue(crOSDTextColor)/2,GetGValue(crOSDTextColor)/2,
					   GetBValue(crOSDTextColor)/2);
			else
				cr=crOSDTextColor;
			PseudoOSD.SetTextColor(cr);
			PseudoOSD.SetPosition(8,8,sz.cx+8,sz.cy+8);
			PseudoOSD.Show(OSDFadeTime);
		}
	}
}




LRESULT CALLBACK ViewWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_SIZE:
		if (GetParent(hwndVideoContainer)==hwnd)
			MoveWindow(hwndVideoContainer,0,0,LOWORD(lParam),HIWORD(lParam),
																		TRUE);
		return 0;

	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
	case WM_LBUTTONDBLCLK:
		{
			POINT pt;

			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			MapWindowPoints(hwnd,GetParent(hwnd),&pt,1);
			return SendMessage(GetParent(hwnd),uMsg,wParam,
														MAKELPARAM(pt.x,pt.y));
		}

	case WM_SETCURSOR:
		if (LOWORD(lParam)==HTCLIENT) {
			SetCursor(LoadCursor(NULL,IDC_ARROW));
			return TRUE;
		}
		break;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


LRESULT CALLBACK VideoContainerWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			RECT rcDest,rc;
			HBRUSH hbr;

			BeginPaint(hwnd,&ps);
			DtvEngine.m_MediaViewer.RepaintVideo(hwnd,ps.hdc);
			DtvEngine.m_MediaViewer.GetDestRect(&rcDest);
			hbr=static_cast<HBRUSH>(GetStockObject(BLACK_BRUSH));
			if (ps.rcPaint.top<rcDest.top) {
				rc.left=ps.rcPaint.left;
				rc.top=ps.rcPaint.top;
				rc.right=ps.rcPaint.right;
				rc.bottom=min(rcDest.top,ps.rcPaint.bottom);
				FillRect(ps.hdc,&rc,hbr);
			}
			if (ps.rcPaint.top<rcDest.bottom && ps.rcPaint.bottom>rcDest.top) {
				rc.top=max(rcDest.top,ps.rcPaint.top);
				rc.bottom=min(rcDest.bottom,ps.rcPaint.bottom);
				if (ps.rcPaint.left<rcDest.left) {
					rc.left=ps.rcPaint.left;
					rc.right=min(rcDest.left,ps.rcPaint.right);
					FillRect(ps.hdc,&rc,hbr);
				}
				if (ps.rcPaint.right>rcDest.right) {
					rc.left=max(rcDest.right,ps.rcPaint.left);
					rc.right=ps.rcPaint.right;
					FillRect(ps.hdc,&rc,hbr);
				}
			}
			if (ps.rcPaint.bottom>rcDest.bottom) {
				rc.left=ps.rcPaint.left;
				rc.top=max(rcDest.bottom,ps.rcPaint.top);
				rc.right=ps.rcPaint.right;
				rc.bottom=ps.rcPaint.bottom;
				FillRect(ps.hdc,&rc,hbr);
			}
			EndPaint(hwnd,&ps);
		}
		return 0;

	case WM_MOVE:
		if (!DtvEngine.m_MediaViewer.GetVMR9())
			break;
	case WM_SIZE:
		DtvEngine.SetViewSize(LOWORD(lParam),HIWORD(lParam));
		return 0;

	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
	case WM_LBUTTONDBLCLK:
	case WM_MOUSEMOVE:
		{
			POINT pt;

			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			MapWindowPoints(hwnd,GetParent(hwnd),&pt,1);
			return SendMessage(GetParent(hwnd),uMsg,wParam,
														MAKELPARAM(pt.x,pt.y));
		}
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


static void PopupMenu(int x,int y)
{
	static BOOL fPopup=FALSE;

	if (!fPopup) {
		fPopup=TRUE;
		TrackPopupMenu(GetSubMenu(hmenuMain,0),TPM_RIGHTBUTTON,x,y,0,hwndMain,
																		NULL);
		fPopup=FALSE;
	} else
		EndMenu();
}


static void OnMouseWheel(HWND hwnd,WPARAM wParam,LPARAM lParam)
{
	int Mode;

	if (wParam&MK_SHIFT)
		Mode=WheelShiftMode;
	else
		Mode=WheelMode;
	if (hwnd==hwndMain) {
		POINT pt;
		RECT rc;

		pt.x=GET_X_LPARAM(lParam);
		pt.y=GET_Y_LPARAM(lParam);
		StatusView.GetRect(&rc);
		if (PtInRect(&rc,pt)) {
			switch (StatusView.GetCurItem()) {
			case STATUS_ITEM_CHANNEL:		Mode=WHEEL_MODE_CHANNEL;	break;
			//case STATUS_ITEM_VIDEOSIZE:		Mode=WHEEL_MODE_ZOOM;		break;
			case STATUS_ITEM_VOLUME:		Mode=WHEEL_MODE_VOLUME;		break;
			case STATUS_ITEM_AUDIOCHANNEL:	Mode=WHEEL_MODE_STEREOMODE;	break;
			}
		}
	}
	switch (Mode) {
	case WHEEL_MODE_VOLUME:
		SendMessage(hwndMain,WM_COMMAND,
			GET_WHEEL_DELTA_WPARAM(wParam)>=0?CM_VOLUME_UP:CM_VOLUME_DOWN,0);
		break;
	case WHEEL_MODE_CHANNEL:
		{
			bool fUp;

			if (fWheelChannelReverse)
				fUp=GET_WHEEL_DELTA_WPARAM(wParam)>0;
			else
				fUp=GET_WHEEL_DELTA_WPARAM(wParam)<0;
			WheelCurrentChannelNo=GetNextChannel(fUp);
			if (WheelCurrentChannelNo>0) {
				fWheelChannelChanging=true;
				StatusView.UpdateItem(STATUS_ITEM_CHANNEL);
				if (fUseOSD)
					ShowChannelOSD();
				SetTimer(hwndMain,TIMER_ID_WHEELCHANNELCHANGE,
													WheelChannelDelay,NULL);
			}
		}
		break;
	case WHEEL_MODE_STEREOMODE:
		if (CurrentNumAudioChannels==2)
			SendMessage(hwndMain,WM_COMMAND,CM_STEREOMODE,0);
		break;
	case WHEEL_MODE_ZOOM:
		if (!IsZoomed(hwndMain) && !fFullscreen) {
			int Zoom;

			Zoom=CalcZoomRate();
			if (GET_WHEEL_DELTA_WPARAM(wParam)>=0)
				Zoom+=5;
			else
				Zoom-=5;
			SetZoomRate(Zoom);
		}
		break;
	}
}


class CFullscreen {
	HWND m_hwnd;
	bool m_fShowCursor;
	bool m_fMenu;
	static CFullscreen *GetThis(HWND hwnd);
	static LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,
												WPARAM wParam,LPARAM lParam);
public:
	CFullscreen();
	~CFullscreen();
	bool Create(HWND hwndOwner);
	void OnRButtonDown();
	void OnMouseMove();
	HWND GetHandle() const { return m_hwnd; }
	static bool Init();
};


bool CFullscreen::Init()
{
	WNDCLASS wc;

	wc.style=0;
	wc.lpfnWndProc=WndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=CreateSolidBrush(RGB(0,0,0));
	wc.lpszMenuName=NULL;
	wc.lpszClassName=FULLSCREEN_WINDOW_CLASS;
	return RegisterClass(&wc)!=0;
}


CFullscreen *CFullscreen::GetThis(HWND hwnd)
{
	return (CFullscreen*)GetWindowLongPtr(hwnd,GWLP_USERDATA);
}


LRESULT CALLBACK CFullscreen::WndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		{
			CFullscreen *pFullscreen=
						(CFullscreen*)((LPCREATESTRUCT)lParam)->lpCreateParams;

			pFullscreen->m_hwnd=hwnd;
			SetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR)pFullscreen);
			SetParent(hwndVideoContainer,hwnd);
			RECT rc;
			GetClientRect(hwnd,&rc);
			MoveWindow(hwndVideoContainer,0,0,rc.right,rc.bottom,FALSE);
			pFullscreen->m_fShowCursor=true;
			pFullscreen->m_fMenu=false;
			SetTimer(hwnd,1,1000,NULL);
		}
		return 0;

	case WM_SIZE:
		MoveWindow(hwndVideoContainer,0,0,LOWORD(lParam),HIWORD(lParam),TRUE);
		return 0;

	case WM_RBUTTONDOWN:
		{
			CFullscreen *pFullscreen=GetThis(hwnd);

			pFullscreen->OnRButtonDown();
		}
		return 0;

	case WM_LBUTTONDBLCLK:
		SendMessage(hwndMain,WM_COMMAND,CM_FULLSCREEN,0);
		return 0;

	case WM_MOUSEMOVE:
		{
			CFullscreen *pFullscreen=GetThis(hwnd);

			pFullscreen->OnMouseMove();
		}
		return 0;

	case WM_TIMER:
		{
			CFullscreen *pFullscreen=GetThis(hwnd);

			if (!pFullscreen->m_fMenu) {
				SetCursor(NULL);
				DtvEngine.m_MediaViewer.HideCursor(true);
				pFullscreen->m_fShowCursor=false;
			}
			KillTimer(hwnd,1);
		}
		return 0;

	case WM_SETCURSOR:
		if (LOWORD(lParam)==HTCLIENT) {
			CFullscreen *pFullscreen=GetThis(hwnd);

			SetCursor(pFullscreen->m_fShowCursor?
											LoadCursor(NULL,IDC_ARROW):NULL);
			return TRUE;
		}
		break;

	case WM_MOUSEWHEEL:
		OnMouseWheel(hwnd,wParam,lParam);
		return 0;

	case WM_KEYDOWN:
		if (wParam==VK_ESCAPE) {
			SendMessage(hwndMain,WM_COMMAND,CM_FULLSCREEN,0);
			return 0;
		}
	case WM_COMMAND:
		return SendMessage(hwndMain,uMsg,wParam,lParam);

	case WM_SYSCOMMAND:
		switch (wParam) {
		case SC_MONITORPOWER:
			if (fNoMonitorLowPower)
				return TRUE;
			break;
		}
		break;

	case WM_CLOSE:
		{
			RECT rc;

			GetClientRect(hwndView,&rc);
			SetParent(hwndVideoContainer,hwndView);
			SendMessage(hwndView,WM_SIZE,0,MAKELPARAM(rc.right,rc.bottom));
		}
		break;

	case WM_DESTROY:
		{
			CFullscreen *pFullscreen=GetThis(hwnd);

			//if (!m_fShowCursor)
				DtvEngine.m_MediaViewer.HideCursor(false);
			pFullscreen->m_hwnd=NULL;
		}
		return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


CFullscreen::CFullscreen()
{
	m_hwnd=NULL;
}


bool CFullscreen::Create(HWND hwndOwner)
{
	HMONITOR hMonitor;
	int x,y,Width,Height;

	hMonitor=MonitorFromWindow(hwndMain,MONITOR_DEFAULTTONEAREST);
	if (hMonitor!=NULL) {
		MONITORINFO mi;

		mi.cbSize=sizeof(MONITORINFO);
		GetMonitorInfo(hMonitor,&mi);
		x=mi.rcMonitor.left;
		y=mi.rcMonitor.top;
		Width=mi.rcMonitor.right-mi.rcMonitor.left;
		Height=mi.rcMonitor.bottom-mi.rcMonitor.top;
	} else {
		x=y=0;
		Width=GetSystemMetrics(SM_CXSCREEN);
		Height=GetSystemMetrics(SM_CYSCREEN);
	}
	if (CreateWindowEx(WS_EX_TOPMOST,FULLSCREEN_WINDOW_CLASS,NULL,
			WS_POPUP | WS_VISIBLE | WS_CLIPCHILDREN,x,y,Width,Height,hwndOwner,
			NULL,hInst,this)==NULL)
		return false;
	return true;
}


CFullscreen::~CFullscreen()
{
	if (m_hwnd!=NULL)
		SendMessage(m_hwnd,WM_CLOSE,0,0);
}


void CFullscreen::OnRButtonDown()
{
	POINT pt;

	GetCursorPos(&pt);
	// j[\̓J[\Ȃ
	KillTimer(m_hwnd,1);
	m_fShowCursor=true;
	DtvEngine.m_MediaViewer.HideCursor(false);
	SetCursor(LoadCursor(NULL,IDC_ARROW));
	m_fMenu=true;
	PopupMenu(pt.x,pt.y);
	m_fMenu=false;
	SetTimer(m_hwnd,1,1000,NULL);
}


void CFullscreen::OnMouseMove()
{
	if (m_fMenu)
		return;
	if (!m_fShowCursor) {
		SetCursor(LoadCursor(NULL,IDC_ARROW));
		DtvEngine.m_MediaViewer.HideCursor(false);
		m_fShowCursor=true;
	}
	SetTimer(m_hwnd,1,1000,NULL);
}


static CFullscreen *pFullscreen=NULL;




static HWND GetVideoHostWindow()
{
	if (fFullscreen)
		return pFullscreen->GetHandle();
	return hwndMain;
}




BOOL CALLBACK AboutDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		{
			HBITMAP hbm;
			RECT rc;

			hbm=LoadBitmap(hInst,MAKEINTRESOURCE(IDB_LOGO));
			SendDlgItemMessage(hDlg,IDC_ABOUT_LOGO,STM_SETIMAGE,IMAGE_BITMAP,
																(LPARAM)hbm);
			GetWindowRect(hDlg,&rc);
			MoveWindow(hDlg,
						(GetSystemMetrics(SM_CXSCREEN)-(rc.right-rc.left))/2,
						(GetSystemMetrics(SM_CYSCREEN)-(rc.bottom-rc.top))/2,
						rc.right-rc.left,rc.bottom-rc.top,FALSE);
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg,LOWORD(wParam));
			return TRUE;
		}
		break;

	case WM_DESTROY:
		{
			HBITMAP hbm=(HBITMAP)SendDlgItemMessage(hDlg,IDC_ABOUT_LOGO,
							STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)(HBITMAP)NULL);

			if (hbm!=NULL)
				DeleteObject(hbm);
		}
		return TRUE;
	}
	return FALSE;
}


static void SetForeground(HWND hwnd)
{
	int TargetID,ForegroundID;

	ForegroundID=GetWindowThreadProcessId(GetForegroundWindow(),NULL);
	TargetID=GetWindowThreadProcessId(hwnd,NULL);
	AttachThreadInput(TargetID,ForegroundID,TRUE);
	SetForegroundWindow(hwnd);
	AttachThreadInput(TargetID,ForegroundID,FALSE);
}


static bool RecChannelChangeDialog(HWND hwndOwner)
{
	return MessageBox(hwndOwner,TEXT("^撆łB`lύX܂?"),
						TEXT("`lύX̊mF"),
						MB_OKCANCEL | MB_DEFBUTTON2 | MB_ICONQUESTION)==IDOK;
}


class MyDtvEngineHandler : public CDtvEngineHandler
{
	const DWORD OnDtvEngineEvent(CDtvEngine *pEngine,const DWORD dwEventID,
																PVOID pParam);
};

const DWORD MyDtvEngineHandler::OnDtvEngineEvent(CDtvEngine *pEngine,
											const DWORD dwEventID,PVOID pParam)
{
	CProgManager *pProgManager=static_cast<CProgManager*>(pParam);
	int NumServices,i;
	TCHAR szServiceName[1024];
	LPTSTR *ppszList;
	bool fReady=false;

	NumServices=pProgManager->GetServiceNum();
	ppszList=new LPTSTR[NumServices];
	for (i=0;i<NumServices;i++) {
		if (!pProgManager->GetServiceName(szServiceName,i)) {
			lstrcpy(szServiceName,TEXT("T[rX擾..."));
			fReady=true;
		}
		ppszList[i]=new TCHAR[lstrlen(szServiceName)+1];
		lstrcpy(ppszList[i],szServiceName);
	}
	PostMessage(hwndMain,WM_APP,
		MAKEWPARAM(MAKEWORD(pEngine->GetService(),NumServices),fReady),
															(LPARAM)ppszList);
	return 0;
}


static MyDtvEngineHandler DtvEngineHandler;


class CMyInfoPanelEventHandler : public CInfoPanelEventHandler {
	POINT m_ptDragStartCursorPos;
	POINT m_ptStartPos;
public:
	void OnSelChange();
	bool OnClose();
	bool OnMoving(RECT *pRect);
	bool OnEnterSizeMove();
	void OnRButtonDown();
	bool OnKeyDown(UINT KeyCode,UINT Flags);
};

void CMyInfoPanelEventHandler::OnSelChange()
{
	if (InfoPanel.GetCurTab()==1) {
		WORD ServiceID;

		DtvEngine.m_ProgManager.GetServiceID(&ServiceID,CurrentService);
		ProgramListView.UpdateProgramList(ServiceID);
	}
}

bool CMyInfoPanelEventHandler::OnClose()
{
	SendMessage(hwndMain,WM_COMMAND,CM_INFORMATION,0);
	return false;
}

bool CMyInfoPanelEventHandler::OnMoving(RECT *pRect)
{
	POINT pt;
	RECT rc;
	int XOffset,YOffset;

	GetCursorPos(&pt);
	pt.x=m_ptStartPos.x+(pt.x-m_ptDragStartCursorPos.x);
	pt.y=m_ptStartPos.y+(pt.y-m_ptDragStartCursorPos.y);
	OffsetRect(pRect,pt.x-pRect->left,pt.y-pRect->top);
	GetWindowRect(hwndMain,&rc);
	XOffset=YOffset=0;
	if (pRect->right>=rc.left-4 && pRect->right<=rc.left+4) {
		XOffset=rc.left-pRect->right;
	} else if (pRect->left>=rc.right-4 && pRect->left<=rc.right+4) {
		XOffset=rc.right-pRect->left;
	} else if (pRect->bottom>=rc.top-4 && pRect->bottom<=rc.top+4) {
		YOffset=rc.top-pRect->bottom;
	} else if (pRect->top>=rc.bottom-4 && pRect->top<=rc.bottom+4) {
		YOffset=rc.bottom-pRect->top;
	}
	OffsetRect(pRect,XOffset,YOffset);
	return true;
}

bool CMyInfoPanelEventHandler::OnEnterSizeMove()
{
	int x,y;

	GetCursorPos(&m_ptDragStartCursorPos);
	InfoPanel.GetPosition(&x,&y,NULL,NULL);
	m_ptStartPos.x=x;
	m_ptStartPos.y=y;
	return true;
}

void CMyInfoPanelEventHandler::OnRButtonDown()
{
	POINT pt;

	GetCursorPos(&pt);
	PopupMenu(pt.x,pt.y);
}

bool CMyInfoPanelEventHandler::OnKeyDown(UINT KeyCode,UINT Flags)
{
	SendMessage(hwndMain,WM_KEYDOWN,KeyCode,Flags);
	return true;
}


static CMyInfoPanelEventHandler InfoEventHandler;


class CMyGetChannelReciver : public CNetworkRemoconReciver {
public:
	void OnRecive(LPCSTR pszText);
};

void CMyGetChannelReciver::OnRecive(LPCSTR pszText)
{
	int Channel;
	LPCSTR p;

	Channel=0;
	for (p=pszText;*p!='\0';p++)
		Channel=Channel*10+(*p-'0');
	PostMessage(hwndMain,WM_APP+1,Channel,0);
}


static CMyGetChannelReciver GetChannelReciver;


class CMyCapturePreviewEvent : public CCapturePreviewEvent {
public:
	CMyCapturePreviewEvent();
	bool OnClose();
};

CMyCapturePreviewEvent::CMyCapturePreviewEvent() :
	CCapturePreviewEvent(&CapturePreview)
{
}

bool CMyCapturePreviewEvent::OnClose()
{
	fShowCapturePreview=false;
	CheckMenuItem(hmenuMain,CM_CAPTUREPREVIEW,MF_BYCOMMAND | MFS_UNCHECKED);
	m_pCapturePreview->ClearImage();
	return true;
}


static CMyCapturePreviewEvent CapturePreviewEvent;


class CMyTracer : public CTracer {
public:
	void OnTrace(LPCTSTR pszOutput)
	{
		StatusView.SetSingleText(pszOutput);
	}
};

static CMyTracer BootTracer;


/*
class CImageSaveParam {
	HGLOBAL m_hGlobal;
	LPTSTR m_pszFileName;
	int m_Format;
	LPTSTR m_pszOption;
public:
	CImageSaveParam(HGLOBAL hGlobal,LPCTSTR pszFileName,int Format,
															LPCTSTR pszOption)
	{
		m_hGlobal=hGlobal;
		m_pszFileName=new TCHAR[lstrlen(pszFileName)+1];
		lstrcpy(m_pszFileName,pszFileName);
		m_Format=Format;
		m_pszOption=new TCHAR[lstrlen(pszOption)+1];
		lstrcpy(m_pszOption,pszOption);
	}
	~CImageSaveParam()
	{
		GlobalFree(m_hGlobal);
		delete [] m_pszFileName;
		delete [] m_pszOption;
	}
	bool SaveImage()
	{
		BITMAPINFO *pbmi;
		bool fResult;

		pbmi=(BITMAPINFO*)GlobalLock(m_hGlobal);
		fResult=ImageCodec.SaveImage(m_pszFileName,m_Format,m_pszOption,
						pbmi,(BYTE*)pbmi+CalcDIBInfoSize(&pbmi->bmiHeader));
		GlobalUnlock(m_hGlobal);
		return fResult;
	}
	static void SaveProc(void *pParam);
};

void CImageSaveParam::SaveProc(void *pParam)
{
	CImageSaveParam *pThis=static_cast<CImageSaveParam*>(pParam);
	bool fResult;

	fResult=pThis->SaveImage();
	if (!fResult)
		PostMessage(hwndMain,WM_APP+2,0,0);
	delete pThis;
	_endthread();
}
*/


// NXĂr
class CMainWindow {
	HWND m_hwnd;
	static CMainWindow *GetThis(HWND hwnd);
	static LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
public:
	CMainWindow();
	HWND Create(DWORD Style,DWORD ExStyle,int Left,int Top,int Width,int Height);
	static bool Initialize();
	void OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify);
	void OnTimer(HWND hwnd,UINT id);
	void OnChannelChange();
	void SetTitleText();
};


bool CMainWindow::Initialize()
{
	WNDCLASS wc;

	wc.style=0;
	wc.lpfnWndProc=WndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON));
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=(HBRUSH)(COLOR_3DFACE+1);
	wc.lpszMenuName=NULL;
	wc.lpszClassName=MAIN_WINDOW_CLASS;
	return RegisterClass(&wc)!=0;
}


CMainWindow::CMainWindow()
{
	m_hwnd=NULL;
}


HWND CMainWindow::Create(DWORD Style,DWORD ExStyle,
										int Left,int Top,int Width,int Height)
{
	return CreateWindowEx(ExStyle,MAIN_WINDOW_CLASS,TITLE_TEXT,Style,
								Left,Top,Width,Height,NULL,NULL,hInst,this);
}


void CMainWindow::OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
{
	switch (id) {
	case CM_ZOOM_25:
	case CM_ZOOM_33:
	case CM_ZOOM_50:
	case CM_ZOOM_66:
	case CM_ZOOM_75:
	case CM_ZOOM_100:
	case CM_ZOOM_150:
	case CM_ZOOM_200:
		{
			WORD Width,Height;

			if (fFullscreen)
				SendMessage(hwnd,WM_COMMAND,CM_FULLSCREEN,0);
			if (IsZoomed(hwnd))
				ShowWindow(hwnd,SW_RESTORE);
			SetZoomRate(ZoomList[id-CM_ZOOM_FIRST]);
		}
		return;

	case CM_ASPECTRATIO:
		SendMessage(hwnd,WM_COMMAND,CM_ASPECTRATIO_FIRST+
			(AspectRatioType+1)%(CM_ASPECTRATIO_LAST-CM_ASPECTRATIO_FIRST+1),0);
		return;

	case CM_ASPECTRATIO_DEFAULT:
	case CM_ASPECTRATIO_16x9:
	case CM_ASPECTRATIO_LETTERBOX:
	case CM_ASPECTRATIO_SUPERFRAME:
	case CM_ASPECTRATIO_SIDECUT:
	case CM_ASPECTRATIO_4x3:
		{
			static const struct {
				BYTE XAspect,YAspect;
				BYTE PanAndScan;
			} AspectRatioList[] = {
				{ 0,0,0},
				{16,9,0},
				{16,9,CMediaViewer::PANANDSCAN_VERT},
				{16,9,CMediaViewer::PANANDSCAN_HORZ |
												CMediaViewer::PANANDSCAN_VERT},
				{ 4,3,CMediaViewer::PANANDSCAN_HORZ},
				{ 4,3,0},
			};
			int i=id-CM_ASPECTRATIO_FIRST;
			int Zoom=CalcZoomRate();

			DtvEngine.m_MediaViewer.ForceAspectRatio(
					AspectRatioList[i].XAspect,AspectRatioList[i].YAspect);
			DtvEngine.m_MediaViewer.SetPanAndScan(
												AspectRatioList[i].PanAndScan);
			DtvEngine.m_MediaViewer.ResizeVideoWindow();
			if (!fFullscreen) {
				WORD Width,Height;

				if (Zoom>0 && DtvEngine.m_MediaViewer.GetCroppedVideoSize(
															&Width,&Height)) {
					int w,h;
					BYTE XAspect,YAspect;

					PanAndScanVideoWidth=w=Width;
					PanAndScanVideoHeight=h=Height;
					if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(
															&XAspect,&YAspect))
							AdjustAspect(&w,&h,XAspect,YAspect);
					AdjustWindowSize(w*Zoom/100,h*Zoom/100);
				} else  if (DtvEngine.m_MediaViewer.GetDestSize(
															&Width,&Height)) {
					AdjustWindowSize(Width,Height);
				}
			}
			AspectRatioType=i;
			CheckMenuRadioItem(hmenuMain,CM_ASPECTRATIO_FIRST,
														CM_ASPECTRATIO_LAST,
							CM_ASPECTRATIO_FIRST+AspectRatioType,MF_BYCOMMAND);
			CheckZoomMenu();
		}
		return;

	case CM_FULLSCREEN:
		if (!fFullscreen)
			SetForeground(hwnd);
		/*
		if (DtvEngine.SwitchFullscreen()) {
			fFullscreen=!fFullscreen;
			CheckMenuItem(hmenuMain,CM_FULLSCREEN,
					MF_BYCOMMAND | (fFullscreen?MFS_CHECKED:MFS_UNCHECKED));
		}
		*/
		if (fFullscreen) {
			delete pFullscreen;
			pFullscreen=NULL;
			fFullscreen=false;
		} else {
			pFullscreen=new CFullscreen;
			if (pFullscreen->Create(hwnd))
				fFullscreen=true;
		}
		CheckMenuItem(hmenuMain,CM_FULLSCREEN,
					MF_BYCOMMAND | (fFullscreen?MFS_CHECKED:MFS_UNCHECKED));
		return;

	case CM_ALWAYSONTOP:
		fAlwaysOnTop=!fAlwaysOnTop;
		SetWindowPos(hwnd,fAlwaysOnTop?HWND_TOPMOST:HWND_NOTOPMOST,
											0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
		CheckMenuItem(hmenuMain,CM_ALWAYSONTOP,
					MF_BYCOMMAND | (fAlwaysOnTop?MFS_CHECKED:MFS_UNCHECKED));
		return;

	case CM_VOLUME_UP:
	case CM_VOLUME_DOWN:
		{
			int Volume;

			if (id==CM_VOLUME_UP) {
				Volume=CurrentVolume+5;
				if (Volume>MAX_VOLUME)
					Volume=MAX_VOLUME;
			} else {
				Volume=CurrentVolume-5;
				if (Volume<0)
					Volume=0;
			}
			if (Volume!=CurrentVolume || fMute)
				SetVolume(Volume);
		}
		return;

	case CM_VOLUME_MUTE:
		{
			int Volume;

			fMute=!fMute;
			DtvEngine.SetVolume(LevelToDeciBel(fMute?0:CurrentVolume));
			StatusView.UpdateItem(STATUS_ITEM_VOLUME);
			ControlPanel.UpdateItem(CONTROLPANEL_ITEM_VOLUME);
			CheckMenuItem(hmenuMain,CM_VOLUME_MUTE,
							MF_BYCOMMAND | (fMute?MFS_CHECKED:MFS_UNCHECKED));
		}
		return;

	case CM_STEREO_THROUGH:
	case CM_STEREO_LEFT:
	case CM_STEREO_RIGHT:
	case CM_STEREOMODE:
		if (id==CM_STEREOMODE)
			CurrentStereoMode=(CurrentStereoMode+1)%3;
		else
			CurrentStereoMode=id-CM_STEREO_THROUGH;
		DtvEngine.SetStereoMode(CurrentStereoMode);
		CheckMenuRadioItem(hmenuMain,CM_STEREO_THROUGH,CM_STEREO_RIGHT,
							CM_STEREO_THROUGH+CurrentStereoMode,MF_BYCOMMAND);
		StatusView.UpdateItem(STATUS_ITEM_AUDIOCHANNEL);
		return;

	case CM_CAPTURE:
		SendMessage(hwnd,WM_COMMAND,
								fCaptureIconSaveToFile?CM_SAVEIMAGE:CM_COPY,0);
		return;

	case CM_COPY:
	case CM_SAVEIMAGE:
		{
			BYTE *pDib;
			bool fResult;

			if (DtvEngine.m_MediaViewer.GetGrabber()) {
				pDib=(BYTE*)DtvEngine.m_MediaViewer.DoCapture(1000);
				fResult=pDib!=NULL;
			} else {
				fResult=DtvEngine.m_MediaViewer.GetCurrentImage(&pDib);
			}
			if (!fResult) {
				MessageBox(GetVideoHostWindow(),
						TEXT("݂̉摜擾ł܂B"),TEXT("߂"),
						MB_OK | MB_ICONEXCLAMATION);
				return;
			}
			{
				BITMAPINFOHEADER *pbmih=(BITMAPINFOHEADER*)pDib;
				RECT rc;
				int Left,Top,Width,Height,OrigWidth,OrigHeight;
				SIZE_T Size;
				HGLOBAL hGlobal=NULL;

				OrigWidth=pbmih->biWidth;
				OrigHeight=abs(pbmih->biHeight);
				if (DtvEngine.m_MediaViewer.GetSourceRect(&rc)) {
					WORD VideoWidth,VideoHeight;

					if (DtvEngine.m_MediaViewer.GetOriginalVideoSize(
													&VideoWidth,&VideoHeight)
							&& (VideoWidth!=OrigWidth
								|| VideoHeight!=OrigHeight)) {
						rc.left=rc.left*OrigWidth/VideoWidth;
						rc.top=rc.top*OrigHeight/VideoHeight;
						rc.right=rc.right*OrigWidth/VideoWidth;
						rc.bottom=rc.bottom*OrigHeight/VideoHeight;
					}
					if (rc.right>OrigWidth)
						rc.right=OrigWidth;
					if (rc.bottom>OrigHeight)
						rc.bottom=OrigHeight;
				} else {
					rc.left=0;
					rc.top=0;
					rc.right=OrigWidth;
					rc.bottom=OrigHeight;
				}
				switch (CaptureSize) {
				case CAPTURE_SIZE_ORIGINAL:
					{
						WORD w,h;
						BYTE XAspect,YAspect;

						DtvEngine.m_MediaViewer.GetCroppedVideoSize(&w,&h);
						Width=w;
						Height=h;
						if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(
															&XAspect,&YAspect))
							AdjustAspect(&Width,&Height,XAspect,YAspect);
					}
					break;
				case CAPTURE_SIZE_VIEW:
					{
						WORD w,h;

						DtvEngine.m_MediaViewer.GetDestSize(&w,&h);
						Width=w;
						Height=h;
					}
					break;
				case CAPTURE_SIZE_RAW:
					rc.left=rc.top=0;
					rc.right=OrigWidth;
					rc.bottom=OrigHeight;
					Width=OrigWidth;
					Height=OrigHeight;
					break;
				default:
					Width=CaptureSizeList[CaptureSize].cx;
					Height=CaptureSizeList[CaptureSize].cy;
				}
				hGlobal=ResizeImage((BITMAPINFO*)pbmih,
								pDib+CalcDIBInfoSize(pbmih),&rc,Width,Height);
				if (hGlobal==NULL) {
					CoTaskMemFree(pDib);
					return;
				}
				if (id==CM_COPY) {
					HGLOBAL hCopy;
					SIZE_T Size;

					Size=GlobalSize(hGlobal);
					hCopy=GlobalAlloc(GMEM_MOVEABLE,Size);
					if (hCopy!=NULL) {
						CopyMemory(GlobalLock(hCopy),GlobalLock(hGlobal),Size);
						GlobalUnlock(hCopy);
						GlobalUnlock(hGlobal);
						if (!CapturePreview.SetImage(hCopy))
							GlobalFree(hCopy);
					}
					if (OpenClipboard(hwnd)) {
						EmptyClipboard();
						if (SetClipboardData(CF_DIB,hGlobal)==NULL)
							MessageBox(GetVideoHostWindow(),
								TEXT("Nbv{[hɃf[^ݒł܂B"),
								NULL,MB_OK | MB_ICONEXCLAMATION);
						CloseClipboard();
					} else
						GlobalFree(hGlobal);
				} else {
					TCHAR szFileName[MAX_PATH],szOption[16],szComment[256];
					SYSTEMTIME st;
					int ExtOffset;

					CapturePreview.SetImage(hGlobal);
					PathCombine(szFileName,szCaptureSaveFolder,szCaptureFileName);
					GetLocalTime(&st);
					wsprintf(szFileName+lstrlen(szFileName),
										TEXT("%04d%02d%02d-%02d%02d%02d"),
										st.wYear,st.wMonth,st.wDay,
										st.wHour,st.wMinute,st.wSecond);
					ExtOffset=lstrlen(szFileName);
					wsprintf(szFileName+ExtOffset,TEXT(".%s"),
								ImageCodec.GetExtension(CaptureSaveFormat));
					if (PathFileExists(szFileName)) {
						int i;

						for (i=0;;i++) {
							wsprintf(szFileName+ExtOffset,TEXT("-%d.%s"),
								i+1,
								ImageCodec.GetExtension(CaptureSaveFormat));
							if (!PathFileExists(szFileName))
								break;
						}
					}
					if (lstrcmpi(ImageCodec.EnumSaveFormat(CaptureSaveFormat),
															TEXT("JPEG"))==0) {
						wsprintf(szOption,TEXT("%d"),JPEGQuality);
					} else if (lstrcmpi(ImageCodec.EnumSaveFormat(
										CaptureSaveFormat),TEXT("PNG"))==0) {
						wsprintf(szOption,TEXT("%d"),PNGCompressionLevel);
					} else
						szOption[0]='\0';
					if (fCaptureSetComment) {
						ChannelInfo Info;
						SYSTEMTIME st;
						TCHAR szDate[64],szTime[64];
						CEpgDataInfo *pInfo=
								DtvEngine.GetEpgDataInfo(CurrentService,false);

						if (GetCurrentChannelInfo(&Info))
							wsprintf(szComment,TEXT("%s "),Info.szName);
						else
							szComment[0]='\0';
						GetLocalTime(&st);
						GetDateFormat(LOCALE_USER_DEFAULT,DATE_SHORTDATE,
											&st,NULL,szDate,lengthof(szDate));
						GetTimeFormat(LOCALE_USER_DEFAULT,
											TIME_FORCE24HOURFORMAT,&st,NULL,
											szTime,lengthof(szTime));
						wsprintf(szComment+lstrlen(szComment),
												TEXT("%s %s"),szDate,szTime);
						if (pInfo!=NULL) {
							wsprintf(szComment+lstrlen(szComment),
										TEXT("\r\n%s"),pInfo->GetEventName());
							delete pInfo;
						}
					}
					/*
					CImageSaveParam *pSaveParam;
					pSaveParam=new CImageSaveParam(hGlobal,szFileName,
												CaptureSaveFormat,szOption);
					_beginthread(CImageSaveParam::SaveProc,0,pSaveParam);
					*/
					BITMAPINFO *pbmi=(BITMAPINFO*)GlobalLock(hGlobal);
					if (!ImageCodec.SaveImage(szFileName,CaptureSaveFormat,
							szOption,pbmi,
							(BYTE*)pbmi+CalcDIBInfoSize(&pbmi->bmiHeader),
							fCaptureSetComment?szComment:NULL))
						MessageBox(GetVideoHostWindow(),
							TEXT("摜̕ۑŃG[܂B"),NULL,
							MB_OK | MB_ICONEXCLAMATION);
					GlobalUnlock(hGlobal);
					if (!CapturePreview.HasImage())
						GlobalFree(hGlobal);
				}
				CoTaskMemFree(pDib);
			}
		}
		return;

	case CM_CAPTUREPREVIEW:
		fShowCapturePreview=!fShowCapturePreview;
		if (fShowCapturePreview) {
			CapturePreview.Create(hwnd,
				WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME |
																	WS_VISIBLE,
				WS_EX_TOOLWINDOW);
		} else {
			CapturePreview.Destroy();
			CapturePreview.ClearImage();
		}
		CheckMenuItem(hmenuMain,CM_CAPTUREPREVIEW,
				MF_BYCOMMAND | (fShowCapturePreview?MFS_CHECKED:MFS_UNCHECKED));
		return;

	case CM_OPENCAPTUREFOLDER:
		ShellExecute(NULL,TEXT("open"),szCaptureSaveFolder,NULL,NULL,
																SW_SHOWNORMAL);
		return;

	case CM_RESET:
		DtvEngine.ResetEngine();
		return;

	case CM_RECORD:
	case CM_RECORD_START:
	case CM_RECORD_STOP:
		if (id==CM_RECORD_START) {
			if (fRecording)
				return;
		} else if (id==CM_RECORD_STOP) {
			if (!fRecording)
				return;
		}
		if (fRecording) {
			DtvEngine.m_FileWriter.CloseFile();
			fRecording=false;
			InfoWindow.SetRecordStatus(false);
		} else {
			TCHAR szFileName[MAX_PATH];

			PathCombine(szFileName,szRecordSaveFolder,szRecordFileName);
			if (fAddRecordTime) {
				SYSTEMTIME st;

				if (lstrlen(szFileName)+15>=MAX_PATH) {
					MessageBox(GetVideoHostWindow(),
							TEXT("t@Cētł܂B"),
									TEXT("߂"),MB_OK | MB_ICONEXCLAMATION);
					return;
				}
				GetLocalTime(&st);
				wsprintf(PathFindExtension(szFileName),
										TEXT("%04d%02d%02d_%02d%02d%02d%s"),
										st.wYear,st.wMonth,st.wDay,
										st.wHour,st.wMinute,st.wSecond,
										PathFindExtension(szRecordFileName));
			}
			if (!DtvEngine.m_FileWriter.OpenFile(szFileName,
												CNCachedFile::CNF_SHAREREAD)) {
				MessageBox(GetVideoHostWindow(),
										TEXT("t@CJ܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
				return;
			}
			fRecording=true;
			RecordOption.StartRecord();
			RecordOption.SetStopTimeSpec(false);
			RecordOption.SetStopTime(60*60*1000);
		}
		StatusView.UpdateItem(STATUS_ITEM_RECORD);
		EnableMenuItem(hmenuMain,CM_RECORDOPTION,
						MF_BYCOMMAND | (fRecording?MFS_GRAYED:MFS_ENABLED));
		EnableMenuItem(hmenuMain,CM_RECORDSTOPTIME,
						MF_BYCOMMAND | (fRecording?MFS_ENABLED:MFS_GRAYED));
		return;

	case CM_RECORDOPTION:
		if (IsWindowEnabled(GetVideoHostWindow())) {
			if (RecordOption.ShowDialog(GetVideoHostWindow(),hInst)) {
				TCHAR szFileName[MAX_PATH];

				if (RecordOption.DoFileExistsOperation(
											GetVideoHostWindow(),szFileName)) {
					if (fRecording)
						SendMessage(hwnd,WM_COMMAND,CM_RECORD_STOP,0);
					if (!DtvEngine.m_FileWriter.OpenFile(szFileName,
												CNCachedFile::CNF_SHAREREAD)) {
						MessageBox(GetVideoHostWindow(),
										TEXT("t@CJ܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
						return;
					}
					fRecording=true;
					RecordOption.StartRecord();
					StatusView.UpdateItem(STATUS_ITEM_RECORD);
					EnableMenuItem(hmenuMain,CM_RECORDOPTION,
												MF_BYCOMMAND | MFS_GRAYED);
					EnableMenuItem(hmenuMain,CM_RECORDSTOPTIME,
												MF_BYCOMMAND | MFS_ENABLED);
				}
			}
		}
		return;

#if 0	// ݒ_CAOŎw肷悤ɕύX
	case CM_RECORDFILENAME:
		if (IsWindowEnabled(GetVideoHostWindow())) {
			OPENFILENAME ofn;
			TCHAR szFileName[MAX_PATH];

			lstrcpy(szFileName,szRecordFileName);
			ofn.lStructSize=sizeof(OPENFILENAME);
			ofn.hwndOwner=GetVideoHostWindow();
			ofn.lpstrFilter=
					TEXT("TSt@C(*.ts)\0*.ts\0ׂẴt@C\0*.*\0");
			ofn.lpstrCustomFilter=NULL;
			ofn.nFilterIndex=1;
			ofn.lpstrFile=szFileName;
			ofn.nMaxFile=lengthof(szFileName);
			ofn.lpstrFileTitle=NULL;
			ofn.lpstrInitialDir=NULL;
			ofn.lpstrTitle=TEXT("ۑt@C");
			ofn.Flags=OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
			ofn.lpstrDefExt=TEXT("ts");
#if _WIN32_WINNT>=0x500
			ofn.pvReserved=NULL;
			ofn.dwReserved=0;
			ofn.FlagsEx=0;
#endif
			if (GetSaveFileName(&ofn))
				lstrcpy(szRecordFileName,szFileName);
		}
		return;

	case CM_ADDRECORDTIME:
		fAddRecordTime=!fAddRecordTime;
		CheckMenuItem(hmenuMain,CM_ADDRECORDTIME,
					MF_BYCOMMAND | (fAddRecordTime?MFS_CHECKED:MFS_UNCHECKED));
		return;
#endif

	case CM_RECORDSTOPTIME:
		if (RecordOption.ChangeStopTimeDialog(GetVideoHostWindow(),hInst)) {
			StatusView.UpdateItem(STATUS_ITEM_RECORD);
		}
		return;

	case CM_OPTIONS_RECORD:
		if (IsWindowEnabled(hwnd))
			OptionsDialog(hwnd,OPTIONS_PAGE_RECORD);
		return;

	case CM_INFORMATION:
		fShowInfoWindow=!fShowInfoWindow;
		if (fShowInfoWindow) {
			InfoPanel.SetVisible(true);
		} else {
			InfoPanel.SetVisible(false);
			InfoWindow.Reset();
		}
		CheckMenuItem(hmenuMain,CM_INFORMATION,
				MF_BYCOMMAND | (fShowInfoWindow?MFS_CHECKED:MFS_UNCHECKED));
		return;

	case CM_STATUSBAR:
		{
			fShowStatusBar=!fShowStatusBar;
			if (!IsZoomed(hwnd)) {
				RECT rc;

				GetWindowRect(hwnd,&rc);
				if (fShowStatusBar) {
					StatusView.SetVisible(true);
					rc.bottom+=StatusView.Height();
				} else {
					StatusView.SetVisible(false);
					rc.bottom-=StatusView.Height();
				}
				MoveWindow(hwnd,rc.left,rc.top,
									rc.right-rc.left,rc.bottom-rc.top,TRUE);
			}
			CheckMenuItem(hmenuMain,CM_STATUSBAR,
					MF_BYCOMMAND | (fShowStatusBar?MFS_CHECKED:MFS_UNCHECKED));
		}
		return;

	case CM_TITLEBAR:
		{
			RECT rc;
			DWORD Style;

			fShowTitleBar=!fShowTitleBar;
			GetWindowRect(hwnd,&rc);
			Style=GetWindowLong(hwnd,GWL_STYLE);
			Style^=WS_CAPTION | WS_MINIMIZEBOX | WS_MAXIMIZEBOX;
			SetWindowLong(hwnd,GWL_STYLE,Style);
			if (!IsZoomed(hwnd)) {
				if (fShowTitleBar)
					rc.top-=GetSystemMetrics(SM_CYCAPTION);
				else
					rc.top+=GetSystemMetrics(SM_CYCAPTION);
			}
			SetWindowPos(hwnd,NULL,rc.left,rc.top,
										rc.right-rc.left,rc.bottom-rc.top,
							SWP_NOZORDER | SWP_FRAMECHANGED | SWP_DRAWFRAME);
			CheckMenuItem(hmenuMain,CM_TITLEBAR,
					MF_BYCOMMAND | (fShowTitleBar?MFS_CHECKED:MFS_UNCHECKED));
		}
		return;

	case CM_DECODERPROPERTY:
		// ԈႢT2
		//DtvEngine.DisplayVideoDecoderProperty(hwnd);
		DtvEngine.DisplayVideoDecorderProperty(hwnd);
		return;

	case CM_OPTIONS:
		if (IsWindowEnabled(hwnd))
			OptionsDialog(hwnd);
		return;

	case CM_EXIT:
		SendMessage(hwnd,WM_CLOSE,0,0);
		return;

	case CM_CHANNEL_UP:
	case CM_CHANNEL_DOWN:
		{
			int Channel=GetNextChannel(id==CM_CHANNEL_UP);

			if (Channel>0)
				SendMessage(hwnd,WM_COMMAND,CM_CHANNELNO_FIRST+Channel-1,0);
			else
				SendMessage(hwnd,WM_COMMAND,CM_CHANNEL_FIRST,0);
		}
		return;

	case CM_MENU:
		{
			POINT pt;

			pt.x=0;
			pt.y=0;
			ClientToScreen(hwndView,&pt);
			PopupMenu(pt.x,pt.y);
		}
		return;

	default:
		if (id>=CM_CAPTURESIZE_FIRST && id<=CM_CAPTURESIZE_LAST) {
			CaptureSize=id-CM_CAPTURESIZE_FIRST;
			CheckMenuRadioItem(hmenuMain,CM_CAPTURESIZE_FIRST,CM_CAPTURESIZE_LAST,
								CM_CAPTURESIZE_FIRST+CaptureSize,MF_BYCOMMAND);
			return;
		}
		if (id>=CM_CHANNELNO_FIRST && id<=CM_CHANNELNO_LAST) {
			int No=id-CM_CHANNELNO_FIRST;

			if (pNetworkRemocon!=NULL) {
				if (fRecording && fConfirmRecChannelChange) {
					if (!RecChannelChangeDialog(GetVideoHostWindow()))
						return;
				}
				pNetworkRemocon->SetChannel(No);
				OnChannelChange();
			} else {
				int Index=ChannelList.FindChannelNo(No+1);

				if (Index>=0)
					SendMessage(hwnd,WM_COMMAND,CM_CHANNEL_FIRST+Index,0);
			}
			return;
		}
		if (id>=CM_CHANNEL_FIRST && id<=CM_CHANNEL_LAST) {
			int Channel=id-CM_CHANNEL_FIRST,Space;

			if (fRecording && fConfirmRecChannelChange) {
				if (!RecChannelChangeDialog(GetVideoHostWindow()))
					return;
			}
			Space=ChannelList.GetSpace(Channel);
			if (Space<0)
				Space=CurrentSpace;
			if ((Channel!=CurrentChannel || Space!=CurrentSpace)
					&& DtvEngine.SetChannel(Space,
									ChannelList.GetChannelIndex(Channel))) {
				CurrentSpace=Space;
				CurrentChannel=Channel;
				StatusView.UpdateItem(STATUS_ITEM_CHANNEL);
				CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
				CheckMenuRadioItem(hmenuMain,CM_SPACE_FIRST,
								CM_SPACE_FIRST+NumSpaces-1,
								CM_SPACE_FIRST+CurrentSpace,MF_BYCOMMAND);
				OnChannelChange();
			}
			return;
		}
		if (id>=CM_SERVICE_FIRST && id<=CM_SERVICE_LAST) {
			CurrentService=id-CM_SERVICE_FIRST;
			DtvEngine.SetService(CurrentService);
			CheckMenuRadioItem(hmenuMain,CM_SERVICE_FIRST,
					CM_SERVICE_FIRST+GetMenuItemCount(
						GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_SERVICE))-1,
								CM_CHANNEL_FIRST+CurrentService,MF_BYCOMMAND);
			return;
		}
		if (id>=CM_SPACE_FIRST && id<=CM_SPACE_LAST) {
			int Space=id-CM_SPACE_FIRST;

			if (Space!=CurrentSpace
					&& DtvEngine.SetChannel(Space,
											ChannelList.GetChannelIndex(0))) {
				CurrentSpace=Space;
				CurrentChannel=0;
				StatusView.UpdateItem(STATUS_ITEM_CHANNEL);
				CheckMenuRadioItem(hmenuMain,CM_SPACE_FIRST,
								CM_SPACE_FIRST+NumSpaces-1,
								CM_SPACE_FIRST+CurrentSpace,MF_BYCOMMAND);
				CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
			}
			return;
		}
	}
}


void CMainWindow::OnTimer(HWND hwnd,UINT id)
{
	if (id==TIMER_ID_UPDATE) {
		static unsigned int TimerCount=0;

		WORD Width,Height;
		if (DtvEngine.GetVideoSize(&Width,&Height)) {
			if (Width!=VideoWidth || Height!=VideoHeight) {
				VideoWidth=Width;
				VideoHeight=Height;
				StatusView.UpdateItem(STATUS_ITEM_VIDEOSIZE);
				InfoWindow.SetVideoSize(Width,Height);
			}
			if (DtvEngine.m_MediaViewer.GetCroppedVideoSize(&Width,&Height)) {
				if (Width!=PanAndScanVideoWidth
						|| Height!=PanAndScanVideoHeight) {
					PanAndScanVideoWidth=Width;
					PanAndScanVideoHeight=Height;
					StatusView.UpdateItem(STATUS_ITEM_VIDEOSIZE);
					CheckZoomMenu();
				}
			}
		}

		DWORD ErrCount,ScrambleCount;
		ErrCount=DtvEngine.m_TsPacketParser.GetErrorPacketCount();
		ScrambleCount=DtvEngine.m_TsDescrambler.GetScramblePacketCount();
		if (ErrCount!=ErrorPacketCount
				|| ScrambleCount!=ScramblePacketCount) {
			ErrorPacketCount=ErrCount;
			ScramblePacketCount=ScrambleCount;
			StatusView.UpdateItem(STATUS_ITEM_ERROR);
		}

		int NumChannels;
		// ԈႢT1
		//NumChannels=DtvEngine.GetAudioChannelNum();
		NumChannels=DtvEngine.GetAudioCahnnelNum();
		if (NumChannels>0) {
			if (NumChannels!=CurrentNumAudioChannels) {
				CurrentNumAudioChannels=NumChannels;
				SendMessage(hwnd,WM_COMMAND,CM_STEREO_THROUGH,0);
				//StatusView.UpdateItem(STATUS_ITEM_AUDIOCHANNEL);
			}
		}

		if (fRecording && RecordOption.QueryStop())
			SendMessage(hwnd,WM_COMMAND,CM_RECORD_STOP,0);

		if (TimerCount%4==0) {	// ׌y
			CEpgDataInfo *pInfo=DtvEngine.GetEpgDataInfo(CurrentService,false);

			if (pInfo!=NULL) {
				WCHAR szText[2048];
				ChannelInfo ChInfo;

				if (GetCurrentChannelInfo(&ChInfo))
					wsprintf(szText,TITLE_TEXT TEXT(" - %s / %s"),
										ChInfo.szName,pInfo->GetEventName());
				else
					lstrcpy(szText,TITLE_TEXT);
				GetWindowText(hwndMain,szText+lengthof(szText)/2,lengthof(szText)/2);
				if (lstrcmp(szText,szText+lengthof(szText)/2)!=0)
					SetWindowText(hwndMain,szText);

				CProgramInfoStatusItem *pPgInfoItem=
					dynamic_cast<CProgramInfoStatusItem*>(StatusView.GetItemByID(STATUS_ITEM_PROGRAMINFO));
				if (pPgInfoItem!=NULL && pPgInfoItem->GetVisible()) {
					SYSTEMTIME stStart,stEnd;
					FILETIME ft;

					stStart=pInfo->GetStartTime();
					SystemTimeToFileTime(&stStart,&ft);
					ft+=(LONGLONG)10000000*pInfo->GetDuration();
					FileTimeToSystemTime(&ft,&stEnd);
					_snwprintf(szText,lengthof(szText),
						L"%02d:%02d`%02d:%02d %s",
						stStart.wHour,
						stStart.wMinute,
						stEnd.wHour,
						stEnd.wMinute,
						pInfo->GetEventName());
					pPgInfoItem->SetProgramInfo(szText);
				}
				if (fShowInfoWindow) {
					if (InfoWindow.GetProgramInfoNext()) {
						delete pInfo;
						pInfo=DtvEngine.GetEpgDataInfo(CurrentService,true);
					}
					if (pInfo!=NULL) {
						FILETIME ft;
						ULARGE_INTEGER uliStart;
						ULONGLONG End;
						SYSTEMTIME stStart,stEnd;

						stStart=pInfo->GetStartTime();
						SystemTimeToFileTime(&stStart,&ft);
						uliStart.LowPart=ft.dwLowDateTime;
						uliStart.HighPart=ft.dwHighDateTime;
						End=uliStart.QuadPart+(ULONGLONG)10000000*pInfo->GetDuration();
						ft.dwHighDateTime=(DWORD)(End>>32);
						ft.dwLowDateTime=(DWORD)End;
						FileTimeToSystemTime(&ft,&stEnd);
						_snwprintf(szText,lengthof(szText),
							L"%d/%d/%d(%s) %02d:%02d`%02d:%02d\r\n%s\r\n\r\n%s\r\n\r\n%s",
							stStart.wYear,
							stStart.wMonth,
							stStart.wDay,
							L"\0\0\0\0\0\0y"+stStart.wDayOfWeek*2,
							stStart.wHour,
							stStart.wMinute,
							stEnd.wHour,
							stEnd.wMinute,
							pInfo->GetEventName(),
							pInfo->GetEventText(),
							pInfo->GetEventExtText());
						InfoWindow.SetProgramInfo(szText);
					}
				}
				delete pInfo;
			}
		}

		if (fShowInfoWindow && InfoPanel.GetCurTab()==1 && TimerCount%8==0) {
			WORD ServiceID;

			DtvEngine.m_ProgManager.GetServiceID(&ServiceID,CurrentService);
			ProgramListView.UpdateProgramList(ServiceID);
		}

		StatusView.UpdateItem(STATUS_ITEM_SIGNALLEVEL);
		StatusView.UpdateItem(STATUS_ITEM_CLOCK);

		if (InfoWindow.IsVisible()) {
			BYTE AspectX,AspectY;
			if (DtvEngine.GetVideoAspectRatio(&AspectX,&AspectY))
				InfoWindow.SetAspectRatio(AspectX,AspectY);

			float SignalLevel=DtvEngine.m_BonSrcDecoder.GetSignalLevel();
			if (fUDPDriver || (fHDUSDriver && !fNewHDUSDriver)) {
				InfoWindow.SetBitRate(SignalLevel);
				InfoWindow.ShowSignalLevel(false);
			} else {
				InfoWindow.SetSignalLevel(SignalLevel);
				InfoWindow.SetBitRate(
					((float)DtvEngine.m_BonSrcDecoder.GetBitRate()/
													(float)(1024*1024))*8.0f);
			}

			if (fRecording) {
				InfoWindow.SetRecordStatus(fRecording,
					DtvEngine.m_FileWriter.GetFileName(),
					DtvEngine.m_FileWriter.GetWriteSize(),
					RecordOption.GetRecordTime());
			}
		}
		TimerCount++;
	} else if (id==TIMER_ID_OSD) {
		DtvEngine.m_MediaViewer.ClearOSD();
		KillTimer(hwnd,TIMER_ID_OSD);
	} else if (id==TIMER_ID_DISPLAY) {
		SetThreadExecutionState(ES_DISPLAY_REQUIRED);
	} else if (id==TIMER_ID_WHEELCHANNELCHANGE) {
		fWheelChannelChanging=false;
		SendMessage(hwnd,WM_COMMAND,
								CM_CHANNELNO_FIRST+WheelCurrentChannelNo-1,0);
		KillTimer(hwnd,TIMER_ID_WHEELCHANNELCHANGE);
	}
}


void CMainWindow::OnChannelChange()
{
	ChannelInfo Info;

	SetTitleText();
	if (fUseOSD)
		ShowChannelOSD();
	ProgramListView.ClearProgramList();
	if (GetCurrentChannelInfo(&Info))
		ControlPanel.CheckRadioItem(CM_CHANNELNO_FIRST,CM_CHANNELNO_LAST,
										CM_CHANNELNO_FIRST+Info.ChannelNo-1);
}




/*
	EBhE̒[ۂɕ\Ă邩肷
	ꂾƕsSƎv܂
*/
static bool IsWindowEdgeVisible(HWND hwnd,HWND hwndTop,const RECT *pRect,HWND hwndTarget)
{
	RECT rc,rcEdge;
	HWND hwndNext;

	if (hwndTop==hwnd || hwndTop==NULL)
		return true;
	GetWindowRect(hwndTop,&rc);
	hwndNext=GetNextWindow(hwndTop,GW_HWNDNEXT);
	if (hwndTop==hwndTarget || !IsWindowVisible(hwndTop)
			|| rc.left==rc.right || rc.top==rc.bottom)
		return IsWindowEdgeVisible(hwnd,hwndNext,pRect,hwndTarget);
/*
TCHAR sz[64];
if (!GetWindowText(hwndTop,sz,64))
sz[0]='\0';
*/
	if (pRect->top==pRect->bottom) {
/*
TRACE(TEXT("horz edge %d,%d,%d,%d [%d,%d,%d,%d] %08X %s\n"),pRect->left,pRect->top,pRect->right,pRect->bottom,rc.left,rc.top,rc.right,rc.bottom,hwndTop,sz);
*/
		if (rc.top<=pRect->top && rc.bottom>pRect->top) {
			if (rc.left<=pRect->left && rc.right>=pRect->right)
				return false;
			if (rc.left<=pRect->left && rc.right>pRect->left) {
				rcEdge=*pRect;
				rcEdge.right=min(rc.right,pRect->right);
				return IsWindowEdgeVisible(hwnd,hwndNext,&rcEdge,hwndTarget);
			} else if (rc.left>pRect->left && rc.right>=pRect->right) {
				rcEdge=*pRect;
				rcEdge.left=rc.left;
				return IsWindowEdgeVisible(hwnd,hwndNext,&rcEdge,hwndTarget);
			} else if (rc.left>pRect->left && rc.right<pRect->right) {
				rcEdge=*pRect;
				rcEdge.right=rc.left;
				if (IsWindowEdgeVisible(hwnd,hwndNext,&rcEdge,hwndTarget))
					return true;
				rcEdge.left=rc.right;
				rcEdge.right=pRect->right;
				return IsWindowEdgeVisible(hwnd,hwndNext,&rcEdge,hwndTarget);
			}
		}
	} else {
/*
TRACE(TEXT("vert edge %d,%d,%d,%d [%d,%d,%d,%d] %08X %s\n"),pRect->left,pRect->top,pRect->right,pRect->bottom,rc.left,rc.top,rc.right,rc.bottom,hwndTop,sz);
*/
		if (rc.left<=pRect->left && rc.right>pRect->left) {
			if (rc.top<=pRect->top && rc.bottom>=pRect->bottom)
				return false;
			if (rc.top<=pRect->top && rc.bottom>pRect->top) {
				rcEdge=*pRect;
				rcEdge.bottom=min(rc.bottom,pRect->bottom);
				return IsWindowEdgeVisible(hwnd,hwndNext,&rcEdge,hwndTarget);
			} else if (rc.top>pRect->top && rc.bottom>=pRect->bottom) {
				rcEdge=*pRect;
				rcEdge.top=rc.top;
				return IsWindowEdgeVisible(hwnd,hwndNext,&rcEdge,hwndTarget);
			} else if (rc.top>pRect->top && rc.bottom<pRect->bottom) {
				rcEdge=*pRect;
				rcEdge.bottom=rc.top;
				if (IsWindowEdgeVisible(hwnd,hwndNext,&rcEdge,hwndTarget))
					return true;
				rcEdge.top=rc.bottom;
				rcEdge.bottom=pRect->bottom;
				return IsWindowEdgeVisible(hwnd,hwndNext,&rcEdge,hwndTarget);
			}
		}
	}
	return IsWindowEdgeVisible(hwnd,hwndNext,pRect,hwndTarget);
}


struct SnapWindowInfo {
	HWND hwnd;
	RECT rcOriginal;
	RECT rcNearest;
};

static BOOL CALLBACK SnapWindowProc(HWND hwnd,LPARAM lParam)
{
	SnapWindowInfo *pInfo=reinterpret_cast<SnapWindowInfo*>(lParam);

	if (IsWindowVisible(hwnd) && hwnd!=pInfo->hwnd) {
		RECT rc,rcEdge;

		GetWindowRect(hwnd,&rc);
		if (rc.right>rc.left && rc.bottom>rc.top) {
			if (rc.top<pInfo->rcOriginal.bottom && rc.bottom>pInfo->rcOriginal.top) {
				if (abs(rc.left-pInfo->rcOriginal.right)<abs(pInfo->rcNearest.right)) {
					rcEdge.left=rc.left;
					rcEdge.right=rc.left;
					rcEdge.top=max(rc.top,pInfo->rcOriginal.top);
					rcEdge.bottom=min(rc.bottom,pInfo->rcOriginal.bottom);
					if (IsWindowEdgeVisible(hwnd,GetTopWindow(GetDesktopWindow()),&rcEdge,pInfo->hwnd))
						pInfo->rcNearest.right=rc.left-pInfo->rcOriginal.right;
				}
				if (abs(rc.right-pInfo->rcOriginal.left)<abs(pInfo->rcNearest.left)) {
					rcEdge.left=rc.right;
					rcEdge.right=rc.right;
					rcEdge.top=max(rc.top,pInfo->rcOriginal.top);
					rcEdge.bottom=min(rc.bottom,pInfo->rcOriginal.bottom);
					if (IsWindowEdgeVisible(hwnd,GetTopWindow(GetDesktopWindow()),&rcEdge,pInfo->hwnd))
						pInfo->rcNearest.left=rc.right-pInfo->rcOriginal.left;
				}
			}
			if (rc.left<pInfo->rcOriginal.right && rc.right>pInfo->rcOriginal.left) {
				if (abs(rc.top-pInfo->rcOriginal.bottom)<abs(pInfo->rcNearest.bottom)) {
					rcEdge.left=max(rc.left,pInfo->rcOriginal.left);
					rcEdge.right=min(rc.right,pInfo->rcOriginal.right);
					rcEdge.top=rc.top;
					rcEdge.bottom=rc.top;
					if (IsWindowEdgeVisible(hwnd,GetTopWindow(GetDesktopWindow()),&rcEdge,pInfo->hwnd))
						pInfo->rcNearest.bottom=rc.top-pInfo->rcOriginal.bottom;
				}
				if (abs(rc.bottom-pInfo->rcOriginal.top)<abs(pInfo->rcNearest.top)) {
					pInfo->rcNearest.top=rc.bottom-pInfo->rcOriginal.top;
					rcEdge.left=max(rc.left,pInfo->rcOriginal.left);
					rcEdge.right=min(rc.right,pInfo->rcOriginal.right);
					rcEdge.top=rc.bottom;
					rcEdge.bottom=rc.bottom;
					if (IsWindowEdgeVisible(hwnd,GetTopWindow(GetDesktopWindow()),&rcEdge,pInfo->hwnd))
						pInfo->rcNearest.bottom=rc.top-pInfo->rcOriginal.bottom;
				}
			}
		}
	}
	return TRUE;
}


static void SnapWindow(HWND hwnd,RECT *prc)
{
	HMONITOR hMonitor;
	RECT rc;
	SnapWindowInfo Info;
	int XOffset,YOffset;
	int x,y;

	hMonitor=MonitorFromWindow(hwnd,MONITOR_DEFAULTTONEAREST);
	if (hMonitor!=NULL) {
		MONITORINFO mi;

		mi.cbSize=sizeof(MONITORINFO);
		GetMonitorInfo(hMonitor,&mi);
		rc=mi.rcMonitor;
	} else {
		rc.left=0;
		rc.top=0;
		rc.right=GetSystemMetrics(SM_CXSCREEN);
		rc.bottom=GetSystemMetrics(SM_CYSCREEN);
	}
	Info.hwnd=hwnd;
	Info.rcOriginal=*prc;
	Info.rcNearest.left=rc.left-prc->left;
	Info.rcNearest.top=rc.top-prc->top;
	Info.rcNearest.right=rc.right-prc->right;
	Info.rcNearest.bottom=rc.bottom-prc->bottom;
	EnumWindows(SnapWindowProc,reinterpret_cast<LPARAM>(&Info));
	if (abs(Info.rcNearest.left)<abs(Info.rcNearest.right)
			|| Info.rcNearest.left==Info.rcNearest.right)
		XOffset=Info.rcNearest.left;
	else if (abs(Info.rcNearest.left)>abs(Info.rcNearest.right))
		XOffset=Info.rcNearest.right;
	else
		XOffset=0;
	if (abs(Info.rcNearest.top)<abs(Info.rcNearest.bottom)
			|| Info.rcNearest.top==Info.rcNearest.bottom)
		YOffset=Info.rcNearest.top;
	else if (abs(Info.rcNearest.top)>abs(Info.rcNearest.bottom))
		YOffset=Info.rcNearest.bottom;
	else
		YOffset=0;
	if (abs(XOffset)<=SnapToWindowEdgeMargin)
		prc->left+=XOffset;
	if (abs(YOffset)<=SnapToWindowEdgeMargin)
		prc->top+=YOffset;
	prc->right=prc->left+(Info.rcOriginal.right-Info.rcOriginal.left);
	prc->bottom=prc->top+(Info.rcOriginal.bottom-Info.rcOriginal.top);
}


CMainWindow *CMainWindow::GetThis(HWND hwnd)
{
	return reinterpret_cast<CMainWindow*>(GetWindowLongPtr(hwnd,GWLP_USERDATA));
}


LRESULT CALLBACK CMainWindow::WndProc(HWND hwnd,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		{
			LPCREATESTRUCT pcs=reinterpret_cast<LPCREATESTRUCT>(lParam);
			CMainWindow *pThis=static_cast<CMainWindow*>(pcs->lpCreateParams);

			pThis->m_hwnd=hwnd;
			SetWindowLongPtr(hwnd,GWLP_USERDATA,
											reinterpret_cast<LONG_PTR>(pThis));
			hwndView=CreateWindowEx(fClientEdge?WS_EX_CLIENTEDGE:0,
									VIEW_WINDOW_CLASS,NULL,
									WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
									0,0,0,0,hwnd,(HMENU)IDC_VIEW,hInst,NULL);
			hwndVideoContainer=CreateWindowEx(0,VIDEO_CONTAINER_WINDOW_CLASS,
						NULL,WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
						0,0,0,0,hwndView,(HMENU)IDC_VIDEOCONTAINER,hInst,NULL);
			StatusView.Create(hwnd,IDC_STATUS,
				WS_CHILD | (fShowStatusBar?WS_VISIBLE:0),WS_EX_CLIENTEDGE);
			StatusView.AddItem(new CChannelStatusItem);
			StatusView.AddItem(new CVideoSizeStatusItem);
			StatusView.AddItem(new CVolumeStatusItem);
			StatusView.AddItem(new CAudioChannelStatusItem);
			StatusView.AddItem(new CRecordStatusItem);
			StatusView.AddItem(new CCaptureStatusItem);
			StatusView.AddItem(new CErrorStatusItem);
			StatusView.AddItem(new CSignalLevelStatusItem);
			StatusView.AddItem(new CClockStatusItem);
			StatusView.AddItem(new CProgramInfoStatusItem);
			StatusView.SetColor(crStatusBackColor,crStatusTextColor,
						crStatusHighlightBackColor,crStatusHighlightTextColor);
			StatusOptions.ApplyOptions();
			StatusView.SetSingleText(TEXT("N..."));
			hmenuMain=LoadMenu(hInst,MAKEINTRESOURCE(IDM_MENU));
			CheckMenuRadioItem(hmenuMain,CM_ASPECTRATIO_FIRST,
														CM_ASPECTRATIO_LAST,
							CM_ASPECTRATIO_FIRST+AspectRatioType,MF_BYCOMMAND);
			CheckMenuItem(hmenuMain,CM_FULLSCREEN,
				MF_BYCOMMAND | (fFullscreen?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuItem(hmenuMain,CM_ALWAYSONTOP,
				MF_BYCOMMAND | (fAlwaysOnTop?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuRadioItem(hmenuMain,CM_STEREO_THROUGH,CM_STEREO_RIGHT,
							CM_STEREO_THROUGH+CurrentStereoMode,MF_BYCOMMAND);
			/*
			CheckMenuItem(hmenuMain,CM_ADDRECORDTIME,
				MF_BYCOMMAND | (fAddRecordTime?MFS_CHECKED:MFS_UNCHECKED));
			*/
			CheckMenuRadioItem(hmenuMain,CM_CAPTURESIZE_FIRST,CM_CAPTURESIZE_LAST,
								CM_CAPTURESIZE_FIRST+CaptureSize,MF_BYCOMMAND);
			CheckMenuItem(hmenuMain,CM_CAPTUREPREVIEW,
				MF_BYCOMMAND | (fShowCapturePreview?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuItem(hmenuMain,CM_INFORMATION,
				MF_BYCOMMAND | (fShowInfoWindow?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuItem(hmenuMain,CM_STATUSBAR,
				MF_BYCOMMAND | (fShowStatusBar?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuItem(hmenuMain,CM_TITLEBAR,
				MF_BYCOMMAND | (fShowTitleBar?MFS_CHECKED:MFS_UNCHECKED));

			HMENU hSysMenu;
			hSysMenu=GetSystemMenu(hwnd,FALSE);
			AppendMenu(hSysMenu,MFT_SEPARATOR,0,NULL);
			AppendMenu(hSysMenu,MFT_STRING | MFS_ENABLED,SC_ABOUT,
												TEXT("o[W(&A)..."));
		}
		return 0;

	case WM_SIZE:
		{
			int Height;

			Height=HIWORD(lParam);
			if (fShowStatusBar)
				Height-=StatusView.Height();
			MoveWindow(hwndView,0,0,LOWORD(lParam),Height,TRUE);
			if (fShowStatusBar)
				StatusView.Move(0,Height,LOWORD(lParam),StatusView.Height());
			StatusView.UpdateItem(STATUS_ITEM_VIDEOSIZE);
			CheckZoomMenu();
		}
		return 0;

	case WM_SIZING:
		if (GetKeyState(VK_SHIFT)<0?!fAdjustAspectResizing:
													fAdjustAspectResizing) {
			BYTE XAspect,YAspect;

			if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(
														&XAspect,&YAspect)) {
				LPRECT prc=(LPRECT)lParam;
				RECT rcWindow,rcClient;
				int XMargin,YMargin,Width,Height;

				GetWindowRect(hwnd,&rcWindow);
				GetClientRect(hwnd,&rcClient);
				if (fClientEdge) {
					rcClient.right-=GetSystemMetrics(SM_CXEDGE)*2;
					rcClient.bottom-=GetSystemMetrics(SM_CYEDGE)*2;
				}
				if (fShowStatusBar)
					rcClient.bottom-=StatusView.Height();
				if (rcClient.right<=0 || rcClient.bottom<=0)
					break;
				XMargin=(rcWindow.right-rcWindow.left)-rcClient.right;
				YMargin=(rcWindow.bottom-rcWindow.top)-rcClient.bottom;
				Width=(prc->right-prc->left)-XMargin;
				Height=(prc->bottom-prc->top)-YMargin;
				if (Width<=0 || Height<=0)
					break;
				if (wParam==WMSZ_LEFT || wParam==WMSZ_RIGHT)
					Height=Width*YAspect/XAspect;
				else if (wParam==WMSZ_TOP || wParam==WMSZ_BOTTOM)
					Width=Height*XAspect/YAspect;
				else if (Width*YAspect<Height*XAspect)
					Width=Height*XAspect/YAspect;
				else if (Width*YAspect>Height*XAspect)
					Height=Width*YAspect/XAspect;
				if (wParam==WMSZ_LEFT || wParam==WMSZ_TOPLEFT
													|| wParam==WMSZ_BOTTOMLEFT)
					prc->left=prc->right-(Width+XMargin);
				else
					prc->right=prc->left+Width+XMargin;
				if (wParam==WMSZ_TOP || wParam==WMSZ_TOPLEFT
													|| wParam==WMSZ_TOPRIGHT)
					prc->top=prc->bottom-(Height+YMargin);
				else
					prc->bottom=prc->top+Height+YMargin;
				return TRUE;
			}
		}
		break;

	case WM_RBUTTONDOWN:
		if (fFullscreen) {
			pFullscreen->OnRButtonDown();
		} else {
			POINT pt;

			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			ClientToScreen(hwnd,&pt);
			PopupMenu(pt.x,pt.y);
		}
		return 0;

	case WM_NCLBUTTONDOWN:
		if (wParam!=HTCAPTION)
			break;
		SetForeground(hwnd);
	case WM_LBUTTONDOWN:
		/*
		ptDragStartPos.x=GET_X_LPARAM(lParam);
		ptDragStartPos.y=GET_Y_LPARAM(lParam);
		ClientToScreen(hwnd,&ptDragStartPos);
		*/
		GetCursorPos(&ptDragStartPos);
		GetWindowRect(hwnd,&rcDragStart);
		SetCapture(hwnd);
		return 0;

	case WM_NCLBUTTONUP:
	case WM_LBUTTONUP:
		if (GetCapture()==hwnd)
			ReleaseCapture();
		return 0;

	case WM_MOUSEMOVE:
		if (fFullscreen) {
			pFullscreen->OnMouseMove();
			return 0;
		}
		if (GetCapture()==hwnd) {
			POINT pt;
			RECT rc;

			/*
			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			ClientToScreen(hwnd,&pt);
			*/
			GetCursorPos(&pt);
			rc.left=rcDragStart.left+(pt.x-ptDragStartPos.x);
			rc.top=rcDragStart.top+(pt.y-ptDragStartPos.y);
			rc.right=rc.left+(rcDragStart.right-rcDragStart.left);
			rc.bottom=rc.top+(rcDragStart.bottom-rcDragStart.top);
			if (GetKeyState(VK_SHIFT)<0?!fSnapToWindowEdge:fSnapToWindowEdge)
				SnapWindow(hwnd,&rc);
			MoveWindow(hwnd,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,
																		TRUE);
		}
		return 0;

	case WM_LBUTTONDBLCLK:
		SendMessage(hwnd,WM_COMMAND,CM_FULLSCREEN,0);
		return 0;

	case WM_KEYDOWN:
		{
			int Command;

			if (wParam>=VK_F1 && wParam<=VK_F12) {
				if (!fFunctionKeyChangeChannel)
					break;
				Command=CM_CHANNELNO_FIRST+(wParam-VK_F1);
			} else if (wParam>=VK_NUMPAD0 && wParam<=VK_NUMPAD9) {
				if (!fNumPadChangeChannel)
					break;
				if (wParam==VK_NUMPAD0)
					Command=CM_CHANNELNO_FIRST+9;
				else
					Command=CM_CHANNELNO_FIRST+(wParam-VK_NUMPAD1);
			} else if (wParam>='0' && wParam<='9') {
				if (!fDigitKeyChangeChannel)
					break;
				if (wParam=='0')
					Command=CM_CHANNELNO_FIRST+9;
				else
					Command=CM_CHANNELNO_FIRST+(wParam-'1');
			} else if (wParam==VK_UP) {
				Command=CM_VOLUME_UP;
			} else if (wParam==VK_DOWN) {
				Command=CM_VOLUME_DOWN;
			} else if (wParam==VK_LEFT) {
				Command=CM_CHANNEL_DOWN;
			} else if (wParam==VK_RIGHT) {
				Command=CM_CHANNEL_UP;
			} else {
				static const struct {
					WORD KeyCode;
					WORD Command;
				} CommandMap[] = {
					{'A',		CM_ASPECTRATIO},
					{'C',		CM_COPY},
					{'I',		CM_INFORMATION},
					{'R',		CM_RECORD},
					{'S',		CM_STEREOMODE},
					{'T',		CM_ALWAYSONTOP},
					{VK_HOME,	CM_ZOOM_100},
				};
				int i;

				for (i=0;i<lengthof(CommandMap);i++) {
					if (CommandMap[i].KeyCode==wParam)
						break;
				}
				if (i==lengthof(CommandMap))
					break;
				Command=CommandMap[i].Command;
			}
			SendMessage(hwnd,WM_COMMAND,Command,0);
		}
		return 0;

	case WM_MOUSEWHEEL:
		OnMouseWheel(hwnd,wParam,lParam);
		return 0;

	case WM_SYSCOMMAND:
		switch (wParam) {
		case SC_MONITORPOWER:
			if (fNoMonitorLowPower)
				return TRUE;
			break;
		case SC_ABOUT:
			DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hwnd,AboutDlgProc);
			return 0;
		}
		break;

	case WM_APP:
		{
			HMENU hmenu=GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_SERVICE);
			int NumServices=LOWORD(HIBYTE(wParam));
			LPTSTR *ppszList=(LPTSTR*)lParam;
			int Count,i;

			Count=GetMenuItemCount(hmenu);
			for (i=Count-1;i>=0;i--)
				DeleteMenu(hmenu,i,MF_BYPOSITION);
			for (i=0;i<NumServices;i++) {
				AppendMenu(hmenu,MFT_STRING | MFS_ENABLED,CM_SERVICE_FIRST+i,
																ppszList[i]);
				delete [] ppszList[i];
			}
			delete [] ppszList;
			CurrentService=LOWORD(LOBYTE(wParam));
			CheckMenuRadioItem(hmenuMain,CM_SERVICE_FIRST,
				CM_SERVICE_FIRST+NumServices-1,CM_CHANNEL_FIRST+CurrentService,
																MF_BYCOMMAND);
			/*
			if (fUseOSD && HIWORD(wParam)==0)
				ShowChannelOSD();
			*/
			if (pNetworkRemocon!=NULL)
				pNetworkRemocon->GetChannel(&GetChannelReciver);
		}
		return 0;

	case WM_APP+1:
		{
			const CChannelList &List=pNetworkRemocon->GetChannelList();

			if (NetworkRemoconCurChannelNo!=List.GetChannelNo(wParam)) {
				NetworkRemoconCurChannelNo=List.GetChannelNo(wParam);
				CheckMenuRadioItem(hmenuMain,CM_CHANNELNO_FIRST,CM_CHANNELNO_LAST,
					CM_CHANNELNO_FIRST+NetworkRemoconCurChannelNo-1,MF_BYCOMMAND);
				StatusView.UpdateItem(STATUS_ITEM_CHANNEL);
			}
		}
		return 0;

	/*
	case WM_APP+2:
		{
			MessageBox(NULL,TEXT("摜̕ۑŃG[܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		}
		return 0;
	*/

	case WM_DISPLAYCHANGE:
		if (DtvEngine.m_MediaViewer.GetVMR9())
			DtvEngine.m_MediaViewer.DisplayModeChanged();
		break;

	case WM_CLOSE:
		if (fConfirmRecordingExit && fRecording) {
			if (MessageBox(hwnd,
					TEXT("ݘ^撆łB\r\nIĂł?"),
					TEXT("I̊mF"),MB_OKCANCEL | MB_ICONQUESTION)!=IDOK)
				return 0;
		}
		if (fScreenSaverActive)
			SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,TRUE,NULL,0);
		if (fPowerOffActiveOriginal)
			SystemParametersInfo(SPI_SETPOWEROFFACTIVE,TRUE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
		if (fLowPowerActiveOriginal)
			SystemParametersInfo(SPI_SETLOWPOWERACTIVE,TRUE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
		break;

	case WM_DESTROY:
		{
			if (pFullscreen!=NULL) {
				delete pFullscreen;
				pFullscreen=NULL;
			}
			if (pNetworkRemocon!=NULL) {
				delete pNetworkRemocon;
				pNetworkRemocon=NULL;
			}
			if (pRemoteController!=NULL) {
				delete pRemoteController;
				pRemoteController=NULL;
			}
			InfoWindow.Destroy();

			WINDOWPLACEMENT wc;

			wc.length=sizeof(WINDOWPLACEMENT);
			GetWindowPlacement(hwnd,&wc);
			WindowLeft=wc.rcNormalPosition.left;
			WindowTop=wc.rcNormalPosition.top;
			WindowWidth=wc.rcNormalPosition.right-wc.rcNormalPosition.left;
			WindowHeight=wc.rcNormalPosition.bottom-wc.rcNormalPosition.top;
			fWindowMaximize=wc.showCmd==SW_MAXIMIZE;

			KillTimer(hwnd,TIMER_ID_UPDATE);
			if (hDriverLib!=NULL) {
				DtvEngine.CloseEngine();
				FreeLibrary(hDriverLib);
			}
			if (!fUDPDriver && CurrentChannel>=0) {
				OldChannel=ChannelList.GetChannel(CurrentChannel);
				OldSpace=ChannelList.GetSpace(CurrentChannel);
			} else {
				OldChannel=0;
				OldSpace=-1;
			}
			DestroyMenu(hmenuMain);
			SaveSettings();
			PostQuitMessage(0);
		}
		return 0;

	HANDLE_MSG(hwnd,WM_COMMAND,GetThis(hwnd)->OnCommand);
	HANDLE_MSG(hwnd,WM_TIMER,GetThis(hwnd)->OnTimer);

	default:
		if (pRemoteController!=NULL
				&& pRemoteController->TranslateMessage(uMsg,wParam,lParam))
			return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


void CMainWindow::SetTitleText()
{
	ChannelInfo Info;

	if (GetCurrentChannelInfo(&Info)) {
		TCHAR szText[64];

		lstrcpy(szText,TITLE_TEXT TEXT(" - "));
		lstrcat(szText,Info.szName);
		SetWindowText(m_hwnd,szText);
	} else
		SetWindowText(m_hwnd,TITLE_TEXT);
}


static CMainWindow MainWindow;


static void ParseCommandLine(LPCWSTR pszCmdLine)
{
	LPWSTR *ppszArgList;
	int Args;

	ppszArgList=CommandLineToArgvW(pszCmdLine,&Args);
	if (ppszArgList!=NULL) {
		int i;

		for (i=0;i<Args;i++) {
			if (ppszArgList[i][0]=='/' || ppszArgList[i][0]=='-') {
				if (lstrcmpi(ppszArgList[i]+1,TEXT("d"))==0) {
					i++;
					if (i<Args)
						lstrcpyn(szTempDriverFileName,ppszArgList[i],
											lengthof(szTempDriverFileName));
				} else if (lstrcmpi(ppszArgList[i]+1,TEXT("nd"))==0) {
					fTempNoDescramble=true;
				} else if (lstrcmpi(ppszArgList[i]+1,TEXT("nr"))==0) {
					fUseNetworkRemoconCmd=true;
				} else if (lstrcmpi(ppszArgList[i]+1,TEXT("p"))==0) {
					i++;
					if (i<Args)
						UDPPort=_wtoi(ppszArgList[i]);
				}
			}
		}
		LocalFree(ppszArgList);
	}
}


class CAppMutex {
	HANDLE m_hMutex;
	bool m_fAlreadyExists;
public:
	CAppMutex(bool fEnable);
	~CAppMutex();
	bool AlreadyExists() const { return m_fAlreadyExists; }
};

CAppMutex::CAppMutex(bool fEnable)
{
	if (fEnable) {
		m_hMutex=CreateMutex(NULL,TRUE,TEXT("HDUSTest Mutex"));
		m_fAlreadyExists=m_hMutex!=NULL && GetLastError()==ERROR_ALREADY_EXISTS;
	} else {
		m_hMutex=NULL;
		m_fAlreadyExists=false;
	}
}

CAppMutex::~CAppMutex()
{
	if (m_hMutex!=NULL) {
		if (!m_fAlreadyExists)
			ReleaseMutex(m_hMutex);
		CloseHandle(m_hMutex);
	}
}


int APIENTRY _tWinMain(HINSTANCE hInstance,HINSTANCE /*hPrevInstance*/,
												LPTSTR pszCmdLine,int nCmdShow)
{

	hInst=hInstance;

	TCHAR szModuleDir[MAX_PATH];

	GetModuleFileName(NULL,szModuleDir,MAX_PATH);
	lstrcpy(szIniFileName,szModuleDir);
	PathRenameExtension(szIniFileName,TEXT(".ini"));
	lstrcpy(szChannelListFileName,szModuleDir);
	PathRenameExtension(szChannelListFileName,TEXT(".ch"));
	/*
	// TvftHgƂĈ
	if (!PathFileExists(szChannelListFileName)) {
		TCHAR szSample[MAX_PATH];

		lstrcpy(szSample,szChannelListFileName);
		PathRenameExtension(szSample,TEXT(".sample.ch"));
		CopyFile(szSample,szChannelListFileName,TRUE);
	}
	*/
	*(PathFindFileName(szModuleDir)-1)='\0';
	lstrcpy(szRecordSaveFolder,szModuleDir);
	lstrcpy(szRecordFileName,TEXT("Record.ts"));
	lstrcpy(szCaptureSaveFolder,szModuleDir);
	lstrcpy(szCaptureFileName,TEXT("Capture"));

	LoadSettings();

	CAppMutex Mutex(fKeepSingleTask);

	// Ñ`FbN
	if (Mutex.AlreadyExists()) {
		HWND hwnd;

		hwnd=FindWindow(MAIN_WINDOW_CLASS,TITLE_TEXT);
		if (IsWindow(hwnd)) {
			SetForeground(hwnd);
		} else {
			// ł܂ꍇł WinMain ͔̂ł͖Ӗ...
			MessageBox(NULL,
				TEXT("HDUSTest ͊ɋNĂ܂B\r\n")
				TEXT("EBhEȂꍇ̓^XN}l[WɉBĂ܂̂\r\n")
				TEXT("IĂB"),TITLE_TEXT,
												MB_OK | MB_ICONEXCLAMATION);
		}
		return FALSE;
	}

	if (pszCmdLine[0]!='\0')
		ParseCommandLine(pszCmdLine);

	if (szDriverFileName[0]=='\0')
		lstrcpy(szDriverFileName,TEXT("BonDriver_HDUS.dll"));
	if (szTempDriverFileName[0]=='\0')
		lstrcpy(szTempDriverFileName,szDriverFileName);
	if (!fTempNoDescramble)
		fTempNoDescramble=fNoDescramble;
	if (!fUseNetworkRemoconCmd)
		fUseNetworkRemoconCmd=fUseNetworkRemocon;
	if (szNetworkRemoconChFile[0]=='\0')
		lstrcpy(szNetworkRemoconChFile,TEXT("BonDriver_HDUS(HDUS).ChSet.txt"));
	if (*RecordOption.GetFileName()=='\0') {
		TCHAR szFileName[MAX_PATH];

		PathCombine(szFileName,szRecordSaveFolder,szRecordFileName);
		RecordOption.SetFileName(szFileName);
	}

	WNDCLASS wc;

	wc.style=CS_DBLCLKS;
	wc.lpfnWndProc=ViewWndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=CreateSolidBrush(RGB(0,0,0));
	wc.lpszMenuName=NULL;
	wc.lpszClassName=VIEW_WINDOW_CLASS;
	if (RegisterClass(&wc)==0) {
		return 0;
	}
	wc.style=CS_DBLCLKS;
	wc.lpfnWndProc=VideoContainerWndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=NULL;
	wc.hbrBackground=NULL;
	wc.lpszMenuName=NULL;
	wc.lpszClassName=VIDEO_CONTAINER_WINDOW_CLASS;
	if (RegisterClass(&wc)==0) {
		return 0;
	}
	CMainWindow::Initialize();
	CFullscreen::Init();
	CStatusView::Initialize(hInst);
	CInfoPanel::Initialize(hInst);
	CInformation::Initialize(hInst);
	CProgramListView::Initialize(hInst);
	CControlPanel::Initialize(hInst);
	CCapturePreview::Initialize(hInst);
	CPseudoOSD::Initialize(hInst);

	INITCOMMONCONTROLSEX iccex;
	iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
	iccex.dwICC=ICC_UPDOWN_CLASS | ICC_BAR_CLASSES | ICC_DATE_CLASSES;
	InitCommonControlsEx(&iccex);

	hwndMain=MainWindow.Create(
		WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | (fWindowMaximize?WS_MAXIMIZE:0),
		fAlwaysOnTop?WS_EX_TOPMOST:0,
		WindowLeft,WindowTop,WindowWidth,WindowHeight);
	if (hwndMain==NULL) {
		MessageBox(NULL,TEXT("EBhE쐬ł܂B"),NULL,
														MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	ShowWindow(hwndMain,nCmdShow);
	UpdateWindow(hwndMain);
	if (!fShowTitleBar) {
		// ̒iKŃX^CςȂƂȂ
		// ŏ炱̃X^CɂĂLvV\
		// ShowWindow ̑OɓƁA^Cgo[\ĂACRoȂ
		DWORD Style;

		Style=GetWindowLong(hwndMain,GWL_STYLE);
		Style^=WS_CAPTION | WS_MINIMIZEBOX | WS_MAXIMIZEBOX;
		SetWindowLong(hwndMain,GWL_STYLE,Style);
		SetWindowPos(hwndMain,NULL,0,0,0,0,
			SWP_FRAMECHANGED | SWP_DRAWFRAME | SWP_NOZORDER | SWP_NOMOVE | SWP_NOSIZE);
		UpdateWindow(hwndMain);
	}

	hDriverLib=LoadLibrary(szTempDriverFileName);
	if (hDriverLib==NULL) {
		MessageBox(hwndMain,TEXT("hCo[hł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		LoadChannelList(&ChannelList,szChannelListFileName);
	} else {
		LPCTSTR pszName;

		DtvEngine.SetTracer(&BootTracer);
		DtvEngine.m_MediaViewer.SetVMR9(fUseVMR9 && !fUseGrabberFilter);
		DtvEngine.m_MediaViewer.SetGrabber(fUseGrabberFilter);
		if (DtvEngine.OpenEngine(&DtvEngineHandler,hwndVideoContainer,hwndMain,
						hDriverLib,!fTempNoDescramble,szMpeg2DecoderName)) {
			DtvEngine.EnablePreview();
			DtvEngine.SetVolume(LevelToDeciBel(CurrentVolume));
		}
		pszName=DtvEngine.m_BonSrcDecoder.GetTunerName();
		if (pszName!=NULL) {
			if (lstrcmpi(pszName,TEXT("HDUS"))==0)
				fHDUSDriver=true;
			else if (_tcsncmp(pszName,TEXT("UDP/"),4)==0)
				fUDPDriver=true;
		}
		if (fUDPDriver) {
			CurrentChannel=0;
		} else {
			LoadChannelList(&ChannelList,szChannelListFileName);
			ChannelList.SetChannelOffset(FIRST_CHANNEL);
		}
		if (ChannelList.NumChannels()==0) {
			int i;

			for (i=0;(pszName=DtvEngine.m_BonSrcDecoder.GetChannelName(0,i))
																!=NULL;i++) {
				if (fUDPDriver)
					ChannelList.AddChannel(0,i,i+1,pszName);
				else
					ChannelList.AddChannel(-1,FIRST_CHANNEL+i,i+1,pszName);
			}
		}
		SetChannelMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_CHANNEL));
		SetSpaceMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_SPACE));
		TCHAR szDecoder[128];
		// ԈႢT3
		// if (DtvEngine.GetVideoDecoderName(szDecoder,lengthof(szDecoder)))
		if (DtvEngine.GetVideoDecorderName(szDecoder,lengthof(szDecoder)))
			InfoWindow.SetDecoderName(szDecoder);
		SetTimer(hwndMain,TIMER_ID_UPDATE,500,NULL);
	}

	if (!fNoKeyHook && !fNoRemoteController) {
		pRemoteController=new CRemoteController(hwndMain);
		pRemoteController->BeginHook();
	}

	if (!fNoRemoteController) {
		hAccel=LoadAccelerators(hInst,
							MAKEINTRESOURCE(fNoKeyHook?IDA_ACCEL:IDA_ACCEL2));
	} else
		hAccel=NULL;

	if (fUseNetworkRemoconCmd && fUDPDriver && NetworkRemoconPort>0)
		InitNetworkRemocon();

	SetDisplayStatus();

	DtvEngine.SetTracer(NULL);
	StatusView.SetSingleText(NULL);

	InfoPanel.SetCurTabColors(crInfoBackColor,crInfoTextColor,crInfoTextColor);
	InfoPanel.SetEventHandler(&InfoEventHandler);
	InfoPanel.Create(hwndMain,
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_CLIPCHILDREN,
		WS_EX_TOOLWINDOW);

	InfoWindow.SetColor(crInfoBackColor,crInfoTextColor);
	InfoWindow.Create(InfoPanel.GetHandle(),WS_CHILD);
	InfoPanel.AddWindow(&InfoWindow,TEXT(""));

	EpgProgramList.SetEpgDataCapDllUtil(
							DtvEngine.m_TsPacketParser.GetEpgDataCapDllUtil());
	ProgramListView.SetEpgProgramList(&EpgProgramList);
	ProgramListView.SetColors(crInfoBackColor,crInfoTextColor,crInfoTextColor,crInfoBackColor);
	ProgramListView.Create(InfoPanel.GetHandle(),WS_CHILD | WS_VSCROLL);
	InfoPanel.AddWindow(&ProgramListView,TEXT("ԑg\"));

	ControlPanel.SetColors(crInfoBackColor,crInfoTextColor,crInfoTextColor,crInfoBackColor);
	ControlPanel.SetSendMessageWindow(hwndMain);
	{
		int FontHeight=ControlPanel.GetFontHeight();
		int ButtonSize;
		int i;
		TCHAR szText[4];

		ButtonSize=FontHeight+8;
		for (i=0;i<12;i++) {
			CControlPanelButton *pItem;
			bool fEnable;

			wsprintf(szText,TEXT("%d"),i+1);
			pItem=new CControlPanelButton(CM_CHANNELNO_FIRST+i,szText,
					i%6*ButtonSize+4,i/6*ButtonSize+4,ButtonSize,ButtonSize);
			if (pNetworkRemocon!=NULL) {
				fEnable=pNetworkRemocon->GetChannelList().FindChannelNo(i+1)>=0;
			} else {
				fEnable=ChannelList.FindChannelNo(i+1)>=0;
			}
			pItem->SetEnable(fEnable);
			ControlPanel.AddItem(pItem);
		}
		ControlPanel.AddItem(new CVolumeControlItem);
		ControlPanel.AddItem(new COptionsControlItem);
	}
	ControlPanel.Create(InfoPanel.GetHandle(),WS_CHILD);
	InfoPanel.AddWindow(&ControlPanel,TEXT(""));

	InfoPanel.SetCurTab(InfoPanelCurTab);
	if (fShowInfoWindow)
		InfoPanel.SetVisible(true);

	CapturePreview.SetEventHandler(&CapturePreviewEvent);

	if (fUDPDriver) {
		if (UDPPort>1234 && UDPPort<=1243)
			SendMessage(hwndMain,WM_COMMAND,CM_CHANNEL_FIRST+(UDPPort-1234),0);
	} else if (fRestoreChannel && OldChannel>0) {
		int i;

		for (i=0;i<ChannelList.NumChannels();i++) {
			if (ChannelList.GetChannel(i)==OldChannel
					&& ChannelList.GetSpace(i)==OldSpace) {
				SendMessage(hwndMain,WM_COMMAND,CM_CHANNEL_FIRST+i,0);
				break;
			}
		}
	}

	MSG msg;

	while (GetMessage(&msg,NULL,0,0)) {
		if (hAccel==NULL || !TranslateAccelerator(hwndMain,hAccel,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}
